package GUI;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.XMLDecoder;
import java.io.*;
import java.net.*;

import javax.swing.*;

import sit.Klient;
import sit.Server;
import data.Informace;

/**
 * Tda reprezentujc obrazovku pro zahjen hry. V tto tde uivatel zvol hru, kterou chce hrt a poty hr.
 * @author Ondej Papk
 *
 */
public class PanelHry extends JPanel{
	/**
	 * ID pro serializaci
	 */
	private static final long serialVersionUID = -4165544834774387926L;
	/**
	 * JComboBox pro vbr hry.
	 */
	public JComboBox<String> hra=new JComboBox<String>();
	/**
	 * JComboBox pro vbr potu hr.
	 */
	public JComboBox<Integer> hracu=new JComboBox<Integer>();
	/**
	 * JComboBox pro vbr potu hr zench potaem.
	 */
	public JComboBox<Integer> pocitacem=new JComboBox<Integer>();
	/**
	 * JTextField pro zadn ip adresy pro pipojen. 
	 */
	public JTextField ip=new JTextField();
	/**
	 * JCheckBox, kter je zakrtl, pokud chce uivatel pout vlastn inteligenci.
	 */
	public JCheckBox inteligence=new JCheckBox("Vlastn uml inteligence");
	
	/**
	 * Konstruktor pro vytvoen obrazovky.
	 */
	public PanelHry(){
		this.setLayout(new GridBagLayout());
		GridBagConstraints c=new GridBagConstraints();
		c.ipady=5;
		c.ipadx=10;
		c.anchor=GridBagConstraints.EAST;
		c.gridx=0;
		c.gridy=0;
		this.add(new JLabel("Hra:"),c);
		c.anchor=GridBagConstraints.WEST;
		c.gridx=1;
		this.add(hra,c);
		//zmna potu hr, kte sm hrt, pi zmn hry
		hra.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					//ObjectInputStream in2=new ObjectInputStream(new FileInputStream("hry"+File.separatorChar+hra.getSelectedItem()));
					//Informace inf=(Informace) in2.readObject();
					XMLDecoder decoder=new XMLDecoder(new FileInputStream(new File(PanelHry.class.getProtectionDomain().getCodeSource().getLocation().toURI().getPath()).getParentFile().getPath()+File.separator+"hry"+File.separatorChar+hra.getSelectedItem()+".xml"));
					Informace inf=(Informace) decoder.readObject();
					hracu.removeAllItems();
					for(int i=Integer.parseInt(inf.getVzhled().getMin().getText());i<Integer.parseInt(inf.getVzhled().getMax().getText())+1;++i)
						hracu.addItem(i);
					//in2.close();
					decoder.close();
				} catch(NumberFormatException e1){
					hracu.removeAllItems();
					hracu.addItem(1);
				} catch(FileNotFoundException e1){
				} catch (Exception e1) {
				}
				
			}
		});
		c.anchor=GridBagConstraints.EAST;
		c.gridx=0;
		c.gridy=1;
		this.add(new JLabel("Poet hr:"),c);
		c.anchor=GridBagConstraints.WEST;
		c.gridx=1;
		this.add(hracu,c);
		//zmna potu hr zench potaem, pi zmn potu hrajcch hr
		hracu.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				try{
					pocitacem.removeAllItems();
					for(int i=0;i<(int)hracu.getSelectedItem();++i){
						pocitacem.addItem(i);
					}
				} catch(NullPointerException e){
				}
			}
		});
		c.anchor=GridBagConstraints.EAST;
		c.gridx=0;
		c.gridy=2;
		this.add(new JLabel("zench potaem:"),c);
		c.anchor=GridBagConstraints.WEST;
		c.gridx=1;
		this.add(pocitacem,c);
		c.anchor=GridBagConstraints.CENTER;
		c.gridx=0;
		c.gridy=3;
		c.gridwidth=2;
		this.add(inteligence, c);
		c.anchor=GridBagConstraints.EAST;
		c.gridwidth=1;
		c.gridx=0;
		c.gridy=4;
		this.add(new JLabel("Tvoje IP:"),c);
		try {
			c.anchor=GridBagConstraints.WEST;
			c.gridx=1;
			this.add(new JLabel(InetAddress.getLocalHost().getHostAddress()),c);
		} catch (UnknownHostException e) {
			this.add(new JLabel("?"));
		}
		c.anchor=GridBagConstraints.EAST;
		c.gridx=0;
		c.gridy=5;
		this.add(new JLabel("IP pro pipojen:"),c);
		c.anchor=GridBagConstraints.WEST;
		c.gridx=1;
		c.fill=GridBagConstraints.HORIZONTAL;
		this.add(ip,c);
		JButton vytvorit=new JButton("Vytvoit");
		c.fill=GridBagConstraints.NONE;
		c.anchor=GridBagConstraints.EAST;
		c.gridx=0;
		c.gridy=6;
		this.add(vytvorit,c);
		vytvorit.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				Informace inf=null;
				try {
					/*ObjectInputStream in=new ObjectInputStream(new FileInputStream("hry"+File.separatorChar+hra.getSelectedItem()));
					inf=(Informace) in.readObject();
					in.close();*/
					XMLDecoder decoder=new XMLDecoder(new FileInputStream(new File(PanelHry.class.getProtectionDomain().getCodeSource().getLocation().toURI().getPath()).getParentFile().getPath()+File.separator+"hry"+File.separatorChar+hra.getSelectedItem()+".xml"));
					inf=(Informace) decoder.readObject();
					inf.getKarty().obnovit();
					decoder.close();
				} catch (Exception e) {
				}
					new Server(inf, Main.fram);
			}
		});
		JButton pripojit=new JButton("Pipojit");
		c.anchor=GridBagConstraints.WEST;
		c.gridx=1;
		this.add(pripojit,c);
		pripojit.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				Informace inf=null;
				try {
					/*ObjectInputStream in=new ObjectInputStream(new FileInputStream("hry"+File.separatorChar+hra.getSelectedItem()));
					inf=(Informace) in.readObject();
					in.close();*/
					XMLDecoder decoder=new XMLDecoder(new FileInputStream(new File(PanelHry.class.getProtectionDomain().getCodeSource().getLocation().toURI().getPath()).getParentFile().getPath()+File.separator+"hry"+File.separatorChar+hra.getSelectedItem()+".xml"));
					inf=(Informace) decoder.readObject();
					inf.getKarty().obnovit();
					decoder.close();
				} catch (Exception e) {
				}
				new Klient(Main.fram, inf);
			}
		});
	}
}
