package GUI;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Tda reprezentujc obrazovku pro zadvn pravidel. Zde uivatel zadv pravidla a me provdt jejich syntaktickou kontrolu.
 * @author Ondej Papk
 *
 */
public class PanelPravidel extends JPanel{
	/**
	 * ID pro serializaci
	 */
	private static final long serialVersionUID = -7543257645552937396L;
	/**
	 * JTextArea pro zpis pravidel.
	 */
	private JTextArea text=new JTextArea();
	/**
	 * Tlatko, kter zkontroluje syntax pravidel.
	 */
	private JButton kontrola=new JButton("Kontrola");
	/**
	 * JTextArea pro vpis chyb.
	 */
	private JTextArea vysledek=new JTextArea();
	
	/**
	 * Konstruktor pro vytvoen panelu.
	 */
	public PanelPravidel(JFrame frame){
		this.setLayout(new BorderLayout());
		this.add(new JScrollPane(text), BorderLayout.CENTER);
		JPanel panel=new JPanel(new GridLayout(2,1));
		panel.add(kontrola);
		kontrola.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				zkontroluj(text, vysledek);
			}
		});
		vysledek=new JTextArea();
		vysledek.setEditable(false);
		panel.add(new JScrollPane(vysledek));
		this.add(panel, BorderLayout.SOUTH);
	}
	
	/**
	 * Pid listenery po naten. Po naten programu je teba vem komponentm znovu dt jejich listenery.
	 */
	public void obnovit(){
		kontrola.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				zkontroluj(text, vysledek);
			}
		});
	}
	
	/**
	 * Zkontroluje syntax. Pouv se tda Automat balku inteligence.
	 * @param odkud - JTextArea ke zkontrolovn
	 * @param kam - JTextArea pro zpis chyb
	 * @return true jestli je syntax sprvn jinak false
	 */
	public boolean zkontroluj(JTextArea odkud, JTextArea kam){
		inteligence.Automat a=new inteligence.Automat(false, GUI.Main.informace);
		kam.setText(a.vypocet(odkud.getText()));
		return kam.getText().isEmpty();
	}
	
	public PanelPravidel(){}
	
	public JTextArea getText(){
		return text;
	}
	
	public void setText(JTextArea a){
		text=a;
	}
	
	public JButton getKontrola(){
		return kontrola;
	}
	
	public void setKontrola(JButton a){
		kontrola=a;
	}
	
	public JTextArea getVysledek(){
		return vysledek;
	}
	
	public void setVysledek(JTextArea a){
		vysledek=a;
	}
}
