package GUI;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 * Tda reprezentujc obrazovku pro zadvn UI. V tto tde je uivateli umonno napsat si vlastn UI.
 * @author Ondej Papk
 *
 */
public class PanelUI extends JPanel{
	/**
	 * ID pro serializaci
	 */
	private static final long serialVersionUID = -6723673410798565957L;
	/**
	 * JTextArea pro zpis UI.
	 */
	private JTextArea text=new JTextArea();
	/**
	 * Tlatko, kter zkontroluje syntax UI.
	 */
	private JButton kontrola=new JButton("Kontrola");
	/**
	 * JTextArea pro vpis chyb.
	 */
	private JTextArea vysledek=new JTextArea();
	
	/**
	 * Konstruktor pro vytvoen panelu.
	 */
	public PanelUI(JFrame frame){
		this.setLayout(new BorderLayout());
		this.add(new JScrollPane(text), BorderLayout.CENTER);
		JPanel panel=new JPanel(new GridLayout(2,1));
		panel.add(kontrola);
		kontrola.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				zkontroluj(text, vysledek);
			}
		});
		vysledek=new JTextArea();
		vysledek.setEditable(false);
		panel.add(new JScrollPane(vysledek));
		this.add(panel, BorderLayout.SOUTH);
	}
	
	/**
	 * Pid listenery po naten. Po naten hry do programu je teba opt pidat vem komponentm jejich listenery.
	 */
	public void obnovit(){
		kontrola.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				zkontroluj(text, vysledek);
			}
		});
	}
	
	/**
	 * Zkontroluje syntax. Pouv se tda Automat balku inteligence.
	 * @param co - JTextArea ke zkontrolovn
	 * @param kam - JTextArea pro zpis chyb
	 * @return true jestli je syntax sprvn jinak false
	 */
	public boolean zkontroluj(JTextArea co, JTextArea kam){
		inteligence.Automat a=new inteligence.Automat(true, GUI.Main.informace);
		kam.setText(a.vypocet(co.getText()));
		return kam.getText().isEmpty();
	}
	
	public PanelUI(){}
	
	public JTextArea getText(){
		return text;
	}
	
	public void setText(JTextArea a){
		text=a;
	}
	
	public JButton getKontrola(){
		return kontrola;
	}
	
	public void setKontrola(JButton a){
		kontrola=a;
	}
	
	public JTextArea getVysledek(){
		return vysledek;
	}
	
	public void setVysledek(JTextArea a){
		vysledek=a;
	}
}