package GUI;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.*;
import java.util.List;
import javax.swing.*;

/**
 * Tda reprezentujc obrazovku pro vytvoen vzhledu hry. V tto tde uivatel nastavuje, jak bude vypadat vsledn hra.
 * @author Ondej Papk
 *
 */
public class PanelVzhledu extends JPanel{
	/**
	 * ID pro serializaci
	 */
	private static final long serialVersionUID = -1733578727446843344L;
	/**
	 * JTextField urujc nejmen poet hr.
	 */
	private JTextField min=new JTextField();
	/**
	 * JTextField urujc maximln poet hr.
	 */
	private JTextField max=new JTextField();
	/**
	 * Seznam panel obsahujcch informace o jednotlivch komponentch ped hrem. 
	 */
	private List<JPanel> hrac=new LinkedList<JPanel>();
	/**
	 * Seznam panel obsahujcch informace o jednotlivch komponentch na stedu.
	 */
	private List<JPanel> stred=new LinkedList<JPanel>();
	/**
	 * Seznam JtextField pro zadvn nzv komponent u hre.
	 */
	private List<JTextField> nazevHrac=new LinkedList<JTextField>();
	/**
	 * Seznam JTextField pro zadvn umstn komponent u hre.
	 */
	private List<JTextField> umisteniHrac=new LinkedList<JTextField>();
	/**
	 * Seznam JRadioButton s informac, zda je komponenta u hre veejn.
	 */
	private List<JRadioButton> verejneHrac=new LinkedList<JRadioButton>();
	/**
	 * Seznam JTextField pro zadvn nzv komponent na stedu.
	 */
	private List<JTextField> nazevStred=new LinkedList<JTextField>();
	/**
	 * Seznam JTextField pro zadvn umistnm komponent na stedu.
	 */
	private List<JTextField> umisteniStred=new LinkedList<JTextField>();
	/**
	 * Seznam JRadioButton s informac, zda je komponenta na stedu veejn.
	 */
	private List<JRadioButton> verejneStred=new LinkedList<JRadioButton>();
	/**
	 * Slou pro pidn listener po naten.
	 */
	private JPanel[] kObnoveni=new JPanel[2];
	/**
	 * Tlatka, ke kterm je teba pidat listenery po naten.
	 */
	private List<JButton> kObnoveni2=new LinkedList<JButton>();
	/**
	 * Tlatka, ke kterm je teba pidat listenery po naten.
	 */
	private List<JButton> kObnoveni3=new LinkedList<JButton>();
	
	/**
	 * Konstruktor pro vytvoen panelu.
	 */
	public PanelVzhledu(JFrame frame){
		this.setLayout(new GridBagLayout());
		GridBagConstraints c=new GridBagConstraints();
		JPanel panel=new JPanel(new GridLayout(1, 4));
		panel.add(new JLabel("Min hr:"));
		panel.add(min);
		panel.add(new JLabel("Max hr:"));
		panel.add(max);
		c.gridx=0;
		c.gridy=GridBagConstraints.RELATIVE;
		this.add(panel, c);
		JLabel l=new JLabel("Hr:");
		l.setFont(new Font(l.getFont().getFontName(), l.getFont().getStyle(), 20));
		this.add(l, c);
		panel=new JPanel(new GridLayout(0,1));
		panel.add(panelHrace(0, panel));
		kObnoveni[0]=panel;
		this.add(panel, c);
		l=new JLabel("Sted:");
		l.setFont(new Font(l.getFont().getFontName(), l.getFont().getStyle(), 20));
		this.add(l, c);
		panel=new JPanel(new GridLayout(0, 1));
		panel.add(panelStred(0, panel));
		kObnoveni[1]=panel;
		this.add(panel, c);
	}
	
	/**
	 * Vytvo Jpanel s informacemi o jedn komponent ve he. Jedn se o komponentu hre.
	 * @param pozice pozice na kterou se m vloit tento panel.
	 * @param obsah panel, do kterho se vkld.
	 * @return JPanel s informacemi o komponent.
	 */
	JPanel panelHrace(int pozice, final JPanel obsah){
		final JPanel panel=new JPanel(new GridLayout(2,7));
		final JTextField nazev=new JTextField();
		nazevHrac.add(pozice, nazev);
		panel.add(nazev);
		panel.add(new JLabel("Umstn:"));
		final JTextField umisteniX=new JTextField();
		umisteniHrac.add(2*pozice, umisteniX);
		panel.add(umisteniX);
		panel.add(new JLabel("X"));
		final JTextField umisteniY=new JTextField();
		umisteniHrac.add(2*pozice+1, umisteniY);
		panel.add(umisteniY);
		panel.add(new JLabel());
		panel.add(new JLabel());
		panel.add(new JLabel("Karty:"));
		verejneHrac.add(5*pozice, new JRadioButton("na sob", false));
		verejneHrac.add(5*pozice, new JRadioButton("vedle sebe", true));
		ButtonGroup bg=new ButtonGroup();
		bg.add(verejneHrac.get(5*pozice));
		bg.add(verejneHrac.get(5*pozice+1));
		JPanel p=new JPanel(new GridLayout(0, 1));
		p.add(verejneHrac.get(5*pozice));
		p.add(verejneHrac.get(5*pozice+1));
		panel.add(p);
		panel.add(new JLabel("Viditeln:"));
		verejneHrac.add(5*pozice, new JRadioButton("pro nikoho", false));
		verejneHrac.add(5*pozice, new JRadioButton("pro vechny", false));
		verejneHrac.add(5*pozice, new JRadioButton("pro hre", true));
		bg=new ButtonGroup();
		bg.add(verejneHrac.get(5*pozice));
		bg.add(verejneHrac.get(5*pozice+1));
		bg.add(verejneHrac.get(5*pozice+2));
		p=new JPanel(new GridLayout(0, 1));
		p.add(verejneHrac.get(5*pozice));
		p.add(verejneHrac.get(5*pozice+1));
		p.add(verejneHrac.get(5*pozice+2));
		panel.add(p);
		panel.add(new JLabel());
		final JButton minus=new JButton("-");
		final JButton plus=new JButton("+");
		minus.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				obsah.remove(panel);
				verejneHrac.remove(nazevHrac.indexOf(nazev)*5+4);
				verejneHrac.remove(nazevHrac.indexOf(nazev)*5+3);
				verejneHrac.remove(nazevHrac.indexOf(nazev)*5+2);
				verejneHrac.remove(nazevHrac.indexOf(nazev)*5+1);
				verejneHrac.remove(nazevHrac.indexOf(nazev)*5);
				nazevHrac.remove(nazev);
				umisteniHrac.remove(umisteniX);
				umisteniHrac.remove(umisteniY);
				hrac.remove(panel);
				kObnoveni2.remove(minus);
				kObnoveni2.remove(plus);
				for(JPanel p:hrac)
					p.updateUI();
				for(JPanel p:stred)
					p.updateUI();
			}
		});
		plus.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int a=hrac.indexOf(panel);
				obsah.removeAll();
				for(int i=0;i<hrac.size();++i){
					obsah.add(hrac.get(i));
					if(i==a){
						obsah.add(panelHrace(a+1, obsah));
						++i;
					}
				}
				for(JPanel p:hrac)
					p.updateUI();
				for(JPanel p:stred)
					p.updateUI();
			}
		});
		kObnoveni2.add(2*pozice,minus);
		kObnoveni2.add(2*pozice+1,plus);
		panel.add(minus);
		panel.add(plus);
		hrac.add(pozice, panel);
		return panel;
	}
	
	/**
	 * Vytvo Jpanel s informacemi o jedn komponent ve he. Jedn se o komponentu stedu.
	 * @param pozice pozice na kterou se m vloit tento panel.
	 * @param obsah panel, do kterho se vkld.
	 * @return JPanel s informacemi o komponent.
	 */
	JPanel panelStred(int pozice, final JPanel obsah){
		final JPanel panel=new JPanel(new GridLayout(2,7));
		final JTextField nazev=new JTextField();
		nazevStred.add(pozice, nazev);
		panel.add(nazev);
		panel.add(new JLabel("Umstn:"));
		final JTextField umisteniX=new JTextField();
		umisteniStred.add(2*pozice, umisteniX);
		panel.add(umisteniX);
		panel.add(new JLabel("X"));
		final JTextField umisteniY=new JTextField();
		umisteniStred.add(2*pozice+1, umisteniY);
		panel.add(umisteniY);
		panel.add(new JLabel());
		panel.add(new JLabel());
		panel.add(new JLabel("Karty:"));
		verejneStred.add(4*pozice, new JRadioButton("na sob", false));
		verejneStred.add(4*pozice, new JRadioButton("vedle sebe", true));
		ButtonGroup bg=new ButtonGroup();
		bg.add(verejneStred.get(4*pozice));
		bg.add(verejneStred.get(4*pozice+1));
		JPanel p=new JPanel(new GridLayout(0, 1));
		p.add(verejneStred.get(4*pozice));
		p.add(verejneStred.get(4*pozice+1));
		panel.add(p);
		panel.add(new JLabel("Viditeln:"));
		verejneStred.add(4*pozice, new JRadioButton("pro nikoho", false));
		verejneStred.add(4*pozice, new JRadioButton("pro vechny", true));
		bg=new ButtonGroup();
		bg.add(verejneStred.get(4*pozice));
		bg.add(verejneStred.get(4*pozice+1));
		p=new JPanel(new GridLayout(0, 1));
		p.add(verejneStred.get(4*pozice));
		p.add(verejneStred.get(4*pozice+1));
		panel.add(p);
		panel.add(new JLabel());
		final JButton minus=new JButton("-");
		final JButton plus=new JButton("+");
		minus.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				obsah.remove(panel);
				verejneStred.remove(nazevStred.indexOf(nazev)*4+3);
				verejneStred.remove(nazevStred.indexOf(nazev)*4+2);
				verejneStred.remove(nazevStred.indexOf(nazev)*4+1);
				verejneStred.remove(nazevStred.indexOf(nazev)*4);
				nazevStred.remove(nazev);
				umisteniStred.remove(umisteniX);
				umisteniStred.remove(umisteniY);
				stred.remove(panel);
				kObnoveni3.remove(minus);
				kObnoveni3.remove(plus);
				for(JPanel p:hrac)
					p.updateUI();
				for(JPanel p:stred)
					p.updateUI();
			}
		});
		plus.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int a=stred.indexOf(panel);
				obsah.removeAll();
				for(int i=0;i<stred.size();++i){
					obsah.add(stred.get(i));
					if(i==a){
						obsah.add(panelStred(a+1, obsah));
						++i;
					}
				}
				for(JPanel p:hrac)
					p.updateUI();
				for(JPanel p:stred)
					p.updateUI();
			}
		});
		kObnoveni3.add(2*pozice,minus);
		kObnoveni3.add(2*pozice+1,plus);
		panel.add(minus);
		panel.add(plus);
		stred.add(pozice, panel);
		return panel;
	}
	
	/**
	 * Pid listenery po naten hry do programu.
	 */
	public void obnovit(){
		for(int i=0;i<kObnoveni2.size();i+=2){
			final JPanel p=hrac.get(i/2);
			final JButton b1=kObnoveni2.get(i);
			final JButton b2=kObnoveni2.get(i+1);
			final JTextField tf1=nazevHrac.get(i/2);
			final JTextField tf2=umisteniHrac.get(i);
			final JTextField tf3=umisteniHrac.get(i+1);
			final JRadioButton rb1=verejneHrac.get(i/2*5);
			final JRadioButton rb2=verejneHrac.get(i/2*5+1);
			final JRadioButton rb3=verejneHrac.get(i/2*5+2);
			final JRadioButton rb4=verejneHrac.get(i/2*5+3);
			final JRadioButton rb5=verejneHrac.get(i/2*5+4);
			kObnoveni2.get(i).addActionListener(new ActionListener() {
				
				@Override
				public void actionPerformed(ActionEvent arg0) {
					// TODO Auto-generated method stub
					kObnoveni[0].remove(p);
					nazevHrac.remove(tf1);
					umisteniHrac.remove(tf2);
					umisteniHrac.remove(tf3);
					verejneHrac.remove(rb1);
					verejneHrac.remove(rb2);
					verejneHrac.remove(rb3);
					verejneHrac.remove(rb4);
					verejneHrac.remove(rb5);
					hrac.remove(p);
					kObnoveni2.remove(b1);
					kObnoveni2.remove(b2);
					for(JPanel p:hrac)
						p.updateUI();
					for(JPanel p:stred)
						p.updateUI();
				}
			});
			kObnoveni2.get(i+1).addActionListener(new ActionListener() {
				
				@Override
				public void actionPerformed(ActionEvent arg0) {
					// TODO Auto-generated method stub
					int a=hrac.indexOf(p);
					kObnoveni[0].removeAll();
					for(int i=0;i<hrac.size();++i){
						kObnoveni[0].add(hrac.get(i));
						if(i==a){
							kObnoveni[0].add(panelHrace(a+1, kObnoveni[0]));
							++i;
						}
					}
					for(JPanel p:hrac)
						p.updateUI();
					for(JPanel p:stred)
						p.updateUI();
				}
			});
		}
		for(int i=0;i<kObnoveni3.size();i+=2){
			final JPanel p=stred.get(i/2);
			final JButton b1=kObnoveni3.get(i);
			final JButton b2=kObnoveni3.get(i+1);
			final JTextField tf1=nazevStred.get(i/2);
			final JTextField tf2=umisteniStred.get(i);
			final JTextField tf3=umisteniStred.get(i+1);
			final JRadioButton rb1=verejneStred.get(i/2*4);
			final JRadioButton rb2=verejneStred.get(i/2*4+1);
			final JRadioButton rb3=verejneStred.get(i/2*4+2);
			final JRadioButton rb4=verejneStred.get(i/2*4+3);
			kObnoveni3.get(i).addActionListener(new ActionListener() {
				
				@Override
				public void actionPerformed(ActionEvent e) {
					// TODO Auto-generated method stub
					kObnoveni[1].remove(p);
					nazevStred.remove(tf1);
					umisteniStred.remove(tf2);
					umisteniStred.remove(tf3);
					verejneStred.remove(rb1);
					verejneStred.remove(rb2);
					verejneStred.remove(rb3);
					verejneStred.remove(rb4);
					stred.remove(p);
					kObnoveni3.remove(b1);
					kObnoveni3.remove(b2);
					for(JPanel p:hrac)
						p.updateUI();
					for(JPanel p:stred)
						p.updateUI();
				}
			});
			kObnoveni3.get(i+1).addActionListener(new ActionListener() {
				
				@Override
				public void actionPerformed(ActionEvent e) {
					// TODO Auto-generated method stub
					int a=stred.indexOf(p);
					kObnoveni[1].removeAll();
					for(int i=0;i<stred.size();++i){
						kObnoveni[1].add(stred.get(i));
						if(i==a){
							kObnoveni[1].add(panelStred(a+1, kObnoveni[1]));
							++i;
						}
					}
					for(JPanel p:hrac)
						p.updateUI();
					for(JPanel p:stred)
						p.updateUI();
				}
			});
		}
	}
	
	public PanelVzhledu(){}
	
	public JTextField getMin(){
		return min;
	}
	
	public void setMin(JTextField a){
		min=a;
	}
	
	public JTextField getMax(){
		return max;
	}
	
	public void setMax(JTextField a){
		max=a;
	}
	
	public List<JPanel> getHrac(){
		return hrac;
	}
	
	public void setHrac(List<JPanel> a){
		hrac=a;
	}
	
	public List<JPanel> getStred(){
		return stred;
	}
	
	public void setStred(List<JPanel> a){
		stred=a;
	}
	
	public List<JTextField> getNazevHrac(){
		return nazevHrac;
	}
	
	public void setNazevHrac(List<JTextField> a){
		nazevHrac=a;
	}
	
	public List<JTextField> getUmisteniHrac(){
		return umisteniHrac;
	}
	
	public void setUmisteniHrac(List<JTextField> a){
		umisteniHrac=a;
	}
	
	public List<JRadioButton> getVerejneHrac(){
		return verejneHrac;
	}
	
	public void setVerejneHrac(List<JRadioButton> a){
		verejneHrac=a;
	}
	
	public List<JTextField> getNazevStred(){
		return nazevStred;
	}
	
	public void setNazevStred(List<JTextField> a){
		nazevStred=a;
	}
	
	public List<JTextField> getUmisteniStred(){
		return umisteniStred;
	}
	
	public void setUmisteniStred(List<JTextField> a){
		umisteniStred=a;
	}
	
	public List<JRadioButton> getVerejneStred(){
		return verejneStred;
	}
	
	public void setVerejneStred(List<JRadioButton> a){
		verejneStred=a;
	}
	
	public JPanel[] getKObnoveni(){
		return kObnoveni;
	}
	
	public void setKObnoveni(JPanel[] a){
		kObnoveni=a;
	}
	
	public List<JButton> getKObnoveni2(){
		return kObnoveni2;
	}
	
	public void setKObnoveni2(List<JButton> a){
		kObnoveni2=a;
	}
	
	public List<JButton> getKObnoveni3(){
		return kObnoveni3;
	}
	
	public void setKObnoveni3(List<JButton> a){
		kObnoveni3=a;
	}
}
