package data;

import java.io.Serializable;
import GUI.*;

/**
 * Tda s informacemi o vytvoen he. Slou k ukldn a natan her z disku.
 * @author Ondej Papk
 *
 */
public class Informace implements Serializable{
	/**
	 * ID pro serializaci
	 */
	private static final long serialVersionUID = -713490670202761740L;
	/**
	 * Jmno hry.
	 */
	private String nazev;
	/**
	 * JPanel s informacemi o kartch.
	 */
	private PanelKaret karty;
	/**
	 * JPanel s informacemi o vzhledu.
	 */
	private PanelVzhledu vzhled;
	/**
	 * JPanel s informacemi o pravidlech.
	 */
	private PanelPravidel pravidla;
	/**
	 * JPanel s informacemi o UI.
	 */
	private PanelUI UI;
	
	/**
	 * Konstruktor.
	 * @param k JPanel s informacemi o kartch.
	 * @param v JPanel s informacemi o vzhledu.
	 * @param p JPanel s informacemi o pravidlech.
	 * @param u JPanel s informacemi o UI.
	 */
	public Informace(PanelKaret k, PanelVzhledu v, PanelPravidel p, PanelUI u){
		karty=k;
		vzhled=v;
		pravidla=p;
		UI=u;
	}
	
	public Informace(){}
	
	public String getNazev(){
		return nazev;
	}
	
	public void setNazev(String a){
		nazev=a;
	}
	
	public PanelKaret getKarty(){
		return karty;
	}
	
	public void setKarty(PanelKaret a){
		karty=a;
	}
	
	public PanelVzhledu getVzhled(){
		return vzhled;
	}
	
	public void setVzhled(PanelVzhledu a){
		vzhled=a;
	}
	
	public PanelPravidel getPravidla(){
		return pravidla;
	}
	
	public void setPravidla(PanelPravidel a){
		pravidla=a;
	}
	
	public PanelUI getUI(){
		return UI;
	}
	
	public void setUI(PanelUI a){
		UI=a;
	}
}
