package inteligence;

import java.util.*;

import data.Informace;

/**
 * Tda ke kontrole a parsovn pravidel a UI.
 * @author Ondrej Papik
 *
 */
public class Automat{
	/**
	 * Gramatika jazyka pro naprogramovn pravidel a UI. Klem je neterminl ,kter se mn a hodnotou je seznam seznam terminl 
	 * a neterminl, na kter se neterminl zmn.
	 */
	HashMap<String, String[][]> gramatika=new HashMap<String, String[][]>();
	/**
	 * Chyba, kter je nalezena v syntaxi.
	 */
	String chyba="";
	/**
	 * Hlavicky pravidel. Klem je rozparsovan hlavika pravidla a hodnotou je index v programu, kde se nachz dan pravidlo.
	 */
	public HashMap<String[], Integer> hlavicky=new HashMap<String[], Integer>();
	/**
	 * Program s pravidly. Jedn se o pole, kde prvn se rozliuj jednotliv pravidla, a potom se zde nachz naprsovan jednotliv dky.
	 */
	public LinkedList<LinkedList<LinkedList<String>>> program=new LinkedList<LinkedList<LinkedList<String>>>();
	/**
	 * Seznam jednotlivch pkaz. Jedn se o naparsovan jednotliv dky.
	 */
	LinkedList<LinkedList<String>> prikazy=new LinkedList<LinkedList<String>>();
	/**
	 * Seznam s umstnm jednotlivch st programu.
	 */
	LinkedList<Integer> skoky=new LinkedList<Integer>();
	/**
	 * Lokln Stringov promnn.
	 */
	String lokalString="";
	/**
	 * Lokln intov promnn.
	 */
	String lokalInt="";
	/**
	 * Seznam k porovnvn String.
	 */
	public LinkedList<String> porovnatelne=new LinkedList<String>();
	/**
	 * Globln Stringov promnn.
	 */
	public HashMap<String, String> promenneString=new HashMap<String, String>();
	/**
	 * globln intov promnn.
	 */
	public HashMap<String, Integer> promenneInt=new HashMap<String, Integer>();
	
	/**
	 * Konstruktor. Vytvo gramatiku pro pravidla nebo UI.
	 * @param UI - true, jestli se jedn o UI, jinak false
	 * @param inf - informace o he
	 */
	public Automat(boolean UI, Informace inf){
		if(UI){
			String[][] prechody=new String[][]{{"nglobalni_promenne","m","s7","t{","m","nprikazy","m","t}"}};
			gramatika.put("pravidla", prechody);
			prechody=new String[][]{{"tString ","s4","m","nglobalni_int"},{"tint ","s3","m","nglobalni_String"},{"t"}};
			gramatika.put("globalni_promenne", prechody);
			prechody=new String[][]{{"tint ","s3"},{"t"}};
			gramatika.put("globalni_int", prechody);
			prechody=new String[][]{{"tString ","s4"},{"t"}};
			gramatika.put("globalni_String", prechody);
			prechody=new String[][]{{"numisteni_hrac"},{"numisteni_stred"}};
			gramatika.put("umisteni", prechody);
			
			
			prechody=new String[][]{{"tif","m","t(","m","npodminka","m","t)","m","t{","m","nprikazy","m","t}","m","nelse","nprikazy"},
					{"tfor","m","t(","m","nglobalInt","m","t,","m","nvypocet","m","t,","m","nvypocet","m","t)","m","t{","m","nprikazy","m","t}","m","nprikazy"},
					{"nprirazeni"},
					{"tklik","m","t(","m","nco","m","t)","m","t;","m","nprikazy"},
					{"tbutton","m","t(","m","nmisto","m","t)","m","t;","m","nprikazy"},
					{"tshow","m","t(","m","nhodnota","m","t)","m","t;","m","nprikazy"},
					{"t"}};
			gramatika.put("prikazy", prechody);
			prechody=new String[][]{{"nglobalInt","m","t=","m","nhodnota","m","t;","m","nprikazy"},
					{"nglobalString","m","t=","m","nhodnota","m","t;","m","nprikazy"}};
			gramatika.put("prirazeni", prechody);
			prechody=new String[][]{{"telse","m","t{","m","nprikazy","m","t}","m"},{"t"}};
			gramatika.put("else", prechody);
			
			
			prechody=new String[][]{{"tthis","t.","numisteni"},{"tstred","t.","numisteni"},{"nvypocet","t.","numisteni"}};
			gramatika.put("misto", prechody);
			prechody=new String[][]{{"nmisto","nkarta"}};
			gramatika.put("co", prechody);
			prechody=new String[][]{{"t.first"},{"t.last"},{"t.get","m","t(","m","nvypocet","m","t)"},{"t"}};
			gramatika.put("karta", prechody);
			prechody=new String[][]{{"t\"","s5","t\""},{"nvypocet","nmist"},{"nglobalString"},{"nString"},{"nmisto","nkarta","t.","nparametr"},{"nparametr"}};
			gramatika.put("hodnota", prechody);
			prechody=new String[][]{{"t(","m","nvypocet","m","t)","noperator"},{"nglobalInt","noperator"},{"nint","noperator"},{"s6","noperator"}};
			gramatika.put("vypocet", prechody);
			prechody=new String[][]{{"m","t+","m","nvypocet"},{"m","t-","m","nvypocet"},{"m","t*","m","nvypocet"},{"m","t/","m","nvypocet"},{"m","t%","m","nvypocet"},{"t"}};
			gramatika.put("operator", prechody);
			prechody=new String[][]{{"tnot ","m","nhodnota","m","noperator_porovnani","nspojka"},{"nhodnota","m","noperator_porovnani","nspojka"}};
			gramatika.put("podminka", prechody);
			prechody=new String[][]{{"m","t&&","m","npodminka"},{"m","t||","m","npodminka"},{"t"}};
			gramatika.put("spojka", prechody);
			prechody=new String[][]{{"t=","m","nhodnota"},{"t<","m","nhodnota"},{"t>","m","nhodnota"},{"t"}};
			gramatika.put("operator_porovnani", prechody);
			prechody=new String[][]{{"t.size"},{"t.contains(","m","npodminka","m","t)"},{"nkarta","t.","nparametr"}};
			gramatika.put("metoda", prechody);
			prechody=new String[][]{{"t.","numisteni","nmetoda"},{"t"}};
			gramatika.put("mist", prechody);
			
			
			
			prechody=new String[inf.getVzhled().getNazevHrac().size()][1];
			for(int i=0;i<inf.getVzhled().getNazevHrac().size();++i){
				prechody[i][0]="t"+inf.getVzhled().getNazevHrac().get(i).getText();
			}
			gramatika.put("umisteni_hrac", prechody);
			prechody=new String[inf.getVzhled().getNazevStred().size()][1];
			for(int i=0;i<inf.getVzhled().getNazevStred().size();++i){
				prechody[i][0]="t"+inf.getVzhled().getNazevStred().get(i).getText();
			}
			gramatika.put("umisteni_stred", prechody);
			prechody=new String[inf.getKarty().getSeznamParametru().size()][1];
			for(int i=0;i<inf.getKarty().getSeznamParametru().size();++i)
				prechody[i][0]="t"+inf.getKarty().getSeznamParametru().get(i);
			gramatika.put("parametr", prechody);
			Automat aut=new Automat(false, inf);
			aut.vypocet(inf.getPravidla().getText().getText());
			prechody=new String[aut.promenneInt.size()][1];
			int i=0;
			for(String s:aut.promenneInt.keySet()){
				prechody[i][0]="t"+s;
				++i;
			}
			gramatika.put("int", prechody);
			prechody=new String[aut.promenneString.size()][1];
			i=0;
			for(String s:aut.promenneString.keySet()){
				prechody[i][0]="t"+s;
				++i;
			}
			gramatika.put("String", prechody);
		}
		else{
			String[][] prechody=new String[][]{{"tporovnani","m","t=","m","s0","m","nglobalni_promenne","m","s7","npravidlo"},{"nglobalni_promenne","m","s7","npravidlo"},{"s7","npravidlo"}};
			gramatika.put("pravidla", prechody);
			prechody=new String[][]{{"tString ","s4","m","nglobalni_int"},{"tint ","s3","m","nglobalni_String"},{"t"}};
			gramatika.put("globalni_promenne", prechody);
			prechody=new String[][]{{"tint ","s3"},{"t"}};
			gramatika.put("globalni_int", prechody);
			prechody=new String[][]{{"tString ","s4"},{"t"}};
			gramatika.put("globalni_String", prechody);
			prechody=new String[][]{{"tklik","m","t(","m","nhlavicka_klik","m","t)","m","nlokalni_promenne","m","t{","m","nprikazy","m","t}","m","s8","npravidlo"},
					{"tstart","m","t(","m","t)","m","nlokalni_promenne","m","t{","m","nprikazy","m","t}","m","s8","npravidlo"},
					{"tkonec","m","t(","m","t)","m","nlokalni_promenne","m","t{","m","nprikazy","m","t}","m","t{","m","nprikazy","m","t}","m","s8","npravidlo"},
					{"tbutton","m","t(","m","nhlavicka_button","m","t)","m","nlokalni_promenne","m","t{","m","nprikazy","m","t}","m","s8","npravidlo"},{"t"}};
			gramatika.put("pravidlo", prechody);
			prechody=new String[][]{{"tint ","s1","m","nlokalni_String"},{"tString ","s2","m","nlokalni_int"},{"t"}};
			gramatika.put("lokalni_promenne", prechody);
			prechody=new String[][]{{"tint ","s1"},{"t"}};
			gramatika.put("lokalni_int", prechody);
			prechody=new String[][]{{"tString ","s2"},{"t"}};
			gramatika.put("lokalni_String", prechody);
			prechody=new String[][]{{"tthis","m","t,","m","numisteni_hrac","m","t,","m","s6","t,","m","nhlavicka_podminka"},{"tother","m","t,","m","numisteni_hrac","m","t,","m","s6","t,","m","nhlavicka_podminka"},
					{"tstred","m","t,","m","numisteni_stred","m","t,","m","s6","t,","m","nhlavicka_podminka"},{"tall","m","t,","m","numisteni","m","t,","m","s6","t,","m","nhlavicka_podminka"}};
			gramatika.put("hlavicka_klik", prechody);
			prechody=new String[][]{{"tall"},{"npodminka"}};
			gramatika.put("hlavicka_podminka", prechody);
			prechody=new String[][]{{"numisteni_hrac"},{"numisteni_stred"}};
			gramatika.put("umisteni", prechody);
			prechody=new String[][]{{"tthis","m","t,","m","numisteni_hrac"},{"tother","m","t,","m","numisteni_hrac"},
					{"tstred","m","t,","m","numisteni_stred"},{"tall","m","t,","m","numisteni"}};
			gramatika.put("hlavicka_button", prechody);
			prechody=new String[][]{{"tmove","m","t(","m","nco","m","t,","m","nmisto","m","t)","m","t;","m","nprikazy"},
					{"tif","m","t(","m","npodminka","m","t)","m","t{","m","nprikazy","m","t}","m","nelse","nprikazy"},
					{"tfor","m","t(","m","nlokalInt","m","t,","m","nvypocet","m","t,","m","nvypocet","m","t)","m","t{","m","nprikazy","m","t}","m","nprikazy"},
					{"tnext","m","t(","m","nhlavicka_next","m","t)","m","t;","m","nprikazy"},
					{"tshowinf","m","t(","m","nhodnota","m","t)","m","t;","m","nprikazy"},
					{"tlabel","m","t(","m","nmisto","ntext","m","t)","m","t;","m","nprikazy"},
					{"tbutton","m","t(","m","nmisto","ntext","m","t)","m","t;","m","nprikazy"},
					{"tshuffle","m","t(","m","nshuffle_co","m","t,","m","nmisto","m","t)","m","t;","m","nprikazy"},
					{"nprirazeni"},
					{"t"}};
			gramatika.put("prikazy", prechody);
			prechody=new String[][]{{"nlokalInt","m","t=","m","nco_priradit","m","t;","m","nprikazy"},
					{"nlokalString","m","t=","m","nco_priradit","m","t;","m","nprikazy"},
					{"nglobalInt","m","t=","m","nco_priradit","m","t;","m","nprikazy"},
					{"nglobalString","m","t=","m","nco_priradit","m","t;","m","nprikazy"}};
			gramatika.put("prirazeni", prechody);
			prechody=new String[][]{{"t|","m","nvypocet","m","t|"},{"nvypocet"}};
			gramatika.put("hlavicka_next", prechody);
			prechody=new String[][]{{"telse","m","t{","m","nprikazy","m","t}","m"},{"t"}};
			gramatika.put("else", prechody);
			prechody=new String[][]{{"m","t,","m","nhodnota"},{"t"}};
			gramatika.put("text", prechody);
			prechody=new String[][]{{"tall"},{"nco"}};
			gramatika.put("shuffle_co", prechody);
			prechody=new String[][]{{"tstred","t.","numisteni"},{"nvypocet","t.","numisteni"}};
			gramatika.put("misto", prechody);
			prechody=new String[][]{{"tthis"},{"nmisto","nkarta"}};
			gramatika.put("co", prechody);
			prechody=new String[][]{{"t.first"},{"t.last"},{"t.get","m","t(","m","nvypocet","m","t)"},{"t"}};
			gramatika.put("karta", prechody);
			prechody=new String[][]{{"t\"","s5","t\""},{"nvypocet","nmist"},{"nlokalString"},{"nglobalString"},{"nmisto","nmetoda"},{"nparametr"}};
			gramatika.put("hodnota", prechody);
			prechody=new String[][]{{"t(","m","nvypocet","m","t)","noperator"},{"nlokalInt","noperator"},{"nglobalInt","noperator"},{"s6","noperator"}};
			gramatika.put("vypocet", prechody);
			prechody=new String[][]{{"m","t+","m","nvypocet"},{"m","t-","m","nvypocet"},{"m","t*","m","nvypocet"},{"m","t/","m","nvypocet"},{"m","t%","m","nvypocet"},{"t"}};
			gramatika.put("operator", prechody);
			prechody=new String[][]{{"tnot ","m","nhodnota","m","noperator_porovnani","nspojka"},{"nhodnota","m","noperator_porovnani","nspojka"}};
			gramatika.put("podminka", prechody);
			prechody=new String[][]{{"m","t&&","m","npodminka"},{"m","t||","m","npodminka"},{"t"}};
			gramatika.put("spojka", prechody);
			prechody=new String[][]{{"t=","m","nhodnota"},{"t<","m","nhodnota"},{"t>","m","nhodnota"},{"t"}};
			gramatika.put("operator_porovnani", prechody);
			prechody=new String[][]{{"tshow","m","t(","m","nhodnota","nshow_parametr","m","t)"},{"nhodnota"}};
			gramatika.put("co_priradit", prechody);
			prechody=new String[][]{{"m","t,","m","nhodnota","nshow_parametr"},{"t"}};
			gramatika.put("show_parametr", prechody);
			prechody=new String[][]{{"t.","numisteni","nmetoda"},{"t"}};
			gramatika.put("mist", prechody);
			prechody=new String[][]{{"t.size"},{"t.contains(","m","npodminka","m","t)"},{"nkarta","t.","nparametr"}};
			gramatika.put("metoda", prechody);
			
			
			prechody=new String[inf.getVzhled().getNazevHrac().size()][1];
			for(int i=0;i<inf.getVzhled().getNazevHrac().size();++i){
				prechody[i][0]="t"+inf.getVzhled().getNazevHrac().get(i).getText();
			}
			gramatika.put("umisteni_hrac", prechody);
			prechody=new String[inf.getVzhled().getNazevStred().size()][1];
			for(int i=0;i<inf.getVzhled().getNazevStred().size();++i){
				prechody[i][0]="t"+inf.getVzhled().getNazevStred().get(i).getText();
			}
			gramatika.put("umisteni_stred", prechody);
			prechody=new String[inf.getKarty().getSeznamParametru().size()][1];
			for(int i=0;i<inf.getKarty().getSeznamParametru().size();++i)
				prechody[i][0]="t"+inf.getKarty().getSeznamParametru().get(i);
			gramatika.put("parametr", prechody);
		}
	}
	
	/**
	 * Zkontroluje dan text a naparsuje ho.
	 * @param keKontrole - text ke zkontrolovn
	 * @return chyba v programu
	 */
	public String vypocet(String keKontrole){
		LinkedList<String> zasobnik=new LinkedList<String>();
		zasobnik.add("npravidla");
		chyba="";
		zpracuj(keKontrole, 1, zasobnik);
		return chyba;
	}
	
	/**
	 * Rekurzivn metoda na kontrolu textu. Jedn se o zsobnkov automat, kde se zkou pouvat jednotliv pravidla gramatiky a 
	 * pi vynoovn z rekurze dochz k parsovn.
	 * @param keKontrole - zbytek textu ke zkontrolovn.
	 * @param line - dek, na kterm se prv nachz.
	 * @param zasobnik - zsobnk
	 * @return true, jestli je text sprvn napsn, jinak false.
	 */
	boolean zpracuj(String keKontrole, int line, LinkedList<String> zasobnik){
		if(zasobnik.isEmpty())
			if(keKontrole.isEmpty())
				return true;
			else{
				chyba="line "+line+": error";
				return false;
			}
		String prvek=zasobnik.removeLast();
		if(prvek.startsWith("t")){
			prvek=prvek.substring(1);
			if(keKontrole.startsWith(prvek)){
				LinkedList<String> zas=new LinkedList<String>();
				zas.addAll(zasobnik);
				boolean uspech=zpracuj(keKontrole.substring(prvek.length()), line, zas);
				if(uspech){
					if(prvek.equals("}")){
						prikazy.addFirst(new LinkedList<String>());
						prikazy.getFirst().add(prvek);
						skoky.add(-2);
					}
					else if(prvek.equals("{")){
						LinkedList<LinkedList<String>> cast=new LinkedList<LinkedList<String>>();
						while(!prikazy.getFirst().getFirst().equals("}")){
							cast.add(prikazy.removeFirst());
						}
						prikazy.removeFirst();
						program.add(cast);
						skoky.removeLast();
						skoky.add(program.size()-1);
						prikazy.addFirst(new LinkedList<String>());
						prikazy.getFirst().add("");
					}
					else if(prvek.equals(",")){
						prikazy.getFirst().addFirst("");
					}
					else if(prvek.equals(";")){
						prikazy.addFirst(new LinkedList<String>());
						prikazy.getFirst().addFirst("");
					}
					else if(prvek.equals("else")){
						skoky.add(-1);
					}
					else if(prvek.equals("if")){
						String a=prikazy.getFirst().getFirst().substring(1, prikazy.getFirst().getFirst().length()-1);
						LinkedList<String> l=new LinkedList<String>();
						l.add(prvek);
						l.add(a);
						l.add(skoky.removeLast().toString());
						if(!skoky.isEmpty()&&skoky.getLast()==-1){
							skoky.removeLast();
							l.add(skoky.removeLast().toString());
						}
						else
							l.add("-1");
						prikazy.set(0, l);
					}
					else if(prvek.equals("for")){
						prikazy.getFirst().set(0, prikazy.getFirst().getFirst().substring(1));
						String a=prikazy.getFirst().removeLast();
						prikazy.getFirst().add(a.substring(0, a.length()-1));
						prikazy.getFirst().add(skoky.removeLast().toString());
						prikazy.getFirst().addFirst(prvek);
					}
					else if(prvek.equals("move")||prvek.equals("next")||prvek.equals("showinf")||prvek.equals("label")||prvek.equals("button")||prvek.equals("shuffle")||
							(prikazy.size()!=0&&!prikazy.getFirst().getFirst().equals("")&&prikazy.getFirst().getFirst().charAt(0)=='(')&&(prvek.equals("klik")||prvek.equals("button")||prvek.equals("start")||prvek.equals("konec"))){
						prikazy.getFirst().set(0, prikazy.getFirst().getFirst().substring(1));
						String a=prikazy.getFirst().removeLast();
						prikazy.getFirst().add(a.substring(0, a.length()-1));
						prikazy.getFirst().addFirst(prvek);
					}
					else if(prvek.equals("show")){
						LinkedList<String> l=prikazy.removeFirst();
						l.set(0, l.getFirst().substring(1));
						String a=l.removeLast();
						l.add(a.substring(0, a.length()-1));
						String s=prvek;
						while(!l.isEmpty())
							s+=" "+l.removeFirst();
						l.add(s);
						prikazy.addFirst(l);
					}
					else if(!prvek.equals("")){
						prikazy.getFirst().set(0, prvek+prikazy.getFirst().getFirst());
					}
					return uspech;
				}
				else{
					if(chyba.isEmpty()&&(prvek.startsWith(";")||prvek.startsWith(".")||prvek.startsWith("(")||prvek.startsWith(")")||prvek.startsWith("{")||prvek.startsWith("}")
							||prvek.startsWith("+")||prvek.startsWith("-")||prvek.startsWith("*")||prvek.startsWith("/")||prvek.startsWith("%")||prvek.startsWith("=")||prvek.startsWith("<")||prvek.startsWith(">")||prvek.startsWith(",")
							||keKontrole.startsWith(";")||keKontrole.startsWith(".")||keKontrole.startsWith("(")||keKontrole.startsWith(")")||keKontrole.startsWith("{")||keKontrole.startsWith("}")||keKontrole.startsWith(",")
							||keKontrole.startsWith("+")||keKontrole.startsWith("-")||keKontrole.startsWith("*")||keKontrole.startsWith("/")||keKontrole.startsWith("%")||keKontrole.startsWith("=")||keKontrole.startsWith("<")||keKontrole.startsWith(">"))){
						while(zasobnik.getLast().equals("m"))
							zasobnik.removeLast();
						if(zasobnik.getLast().equals("s6"))
							chyba="line "+line+": cislo expected";
						else if(zasobnik.getLast().equals("s5"))
							chyba="line "+line+": String expected";
						else
							chyba="line "+line+": "+zasobnik.getLast().substring(1)+" expected";
					}
					return uspech;
				}
			}
			else
				return false;
		}
		else if(prvek.startsWith("n")){
			prvek=prvek.substring(1);
			for(int i=0;i<gramatika.get(prvek).length;++i){
				LinkedList<String> zas=new LinkedList<String>();
				zas.addAll(zasobnik);
				for(int j=gramatika.get(prvek)[i].length-1;j>-1;--j)
					zas.add(gramatika.get(prvek)[i][j]);
				boolean uspech=zpracuj(keKontrole, line, zas);
				if(uspech){
					if(prvek.equals("prirazeni")){
						String s=prikazy.removeFirst().getFirst();
						prikazy.addFirst(new LinkedList<String>());
						prikazy.getFirst().add("=");
						prikazy.getFirst().add(s.substring(0, s.indexOf("=")));
						prikazy.getFirst().add(s.substring(s.indexOf("=")+1));
					}
					else if(prvek.equals("pravidlo")&&prikazy.size()!=0){
						String s=prikazy.getFirst().removeLast();
						if(s.endsWith("int"))
							s=s.substring(0, s.length()-3);
						else if(s.endsWith("String"))
							s=s.substring(0, s.length()-6);
						if(s.endsWith("int "))
							s=s.substring(0, s.length()-4);
						else if(s.endsWith("String "))
							s=s.substring(0, s.length()-7);
						if(s.endsWith(")"))
							s=s.substring(0, s.length()-1);
						if(!s.isEmpty())
							prikazy.getFirst().add(s);
						String[] key=new String[prikazy.getFirst().size()+2];
						for(int j=0;j<key.length-2;++j)
							key[j]=prikazy.getFirst().get(j);
						key[key.length-2]=lokalString;
						key[key.length-1]=lokalInt;
						hlavicky.put(key, skoky.removeLast());
						if(key[0].equals("konec")){
							key=new String[]{"konec2"};
							hlavicky.put(key, skoky.removeLast());
						}
					}
					return uspech;
				}
				else if(i==gramatika.get(prvek).length-1||!chyba.isEmpty()){
					zasobnik.add(prvek);
					return uspech;
				}
			}
			if(gramatika.get(prvek).length==0)
				return false;
		}
		else if(prvek.startsWith("s")){
			String neco="";
			String[][] promenne=null;
			int stav=Integer.parseInt(prvek.substring(1));
			switch(stav){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
				StringTokenizer st=new StringTokenizer(keKontrole.substring(0, keKontrole.indexOf(";")), ",");
				String[][] porovnatelne=new String[st.countTokens()][1];
				int pocet=st.countTokens();
				for(int i=0;i<pocet;++i){
					String s=st.nextToken();
					s=s.trim();
					if(s.contains("(")||s.contains(")")||s.contains(" ")||s.contains("\t")||s.contains("\n")||s.contains("}")||s.contains("{")){
						chyba="line "+line+":"+"nepripustny symbol";
						return false;
					}
					porovnatelne[i][0]="t"+s;
				}
				switch(stav){
				case 0:
					gramatika.put("porovnatelne", porovnatelne); break;
				case 1:
					gramatika.put("lokalInt", porovnatelne); break;
				case 2:
					gramatika.put("lokalString", porovnatelne); break;
				case 3:
					gramatika.put("globalInt", porovnatelne); break;
				case 4:
					gramatika.put("globalString", porovnatelne); break;
				}
				promenne=porovnatelne;
				keKontrole=keKontrole.substring(keKontrole.indexOf(";")+1);
				break;
			case 5:
				if(keKontrole.substring(0, 1).matches("[a-zA-Z0-9_]")){
					neco+=keKontrole.charAt(0);
					keKontrole=keKontrole.substring(1);
					while(keKontrole.substring(0, 1).matches("[a-zA-Z0-9_]")){
						neco+=keKontrole.charAt(0);
						keKontrole=keKontrole.substring(1);
					}
				}
				else
					return false;
				break;
			case 6:
				if(keKontrole.substring(0, 1).matches("[0-9]")){
					neco+=keKontrole.charAt(0);
					keKontrole=keKontrole.substring(1);
					while(keKontrole.substring(0, 1).matches("[0-9]")){
						neco+=keKontrole.charAt(0);
						keKontrole=keKontrole.substring(1);
					}
				}
				else
					return false;
				break;
			case 7:
				if(!gramatika.containsKey("lokalInt"))
					gramatika.put("lokalInt", new String[0][0]);
				if(!gramatika.containsKey("lokalString"))
					gramatika.put("lokalString", new String[0][0]);
				if(!gramatika.containsKey("globalString"))
					gramatika.put("globalString", new String[0][0]);
				if(!gramatika.containsKey("globalInt"))
					gramatika.put("globalInt", new String[0][0]);
				String[][] s=new String[gramatika.get("globalInt").length+2][1];
				for(int i=0;i<s.length-2;++i)
					s[i][0]=gramatika.get("globalInt")[i][0];
				s[s.length-2][0]="tpocethracu";
				s[s.length-1][0]="ttah";
				gramatika.put("globalInt", s);
				break;
			case 8:
				gramatika.put("lokalInt", new String[0][0]);
				gramatika.put("lokalString", new String[0][0]);
				break;
			}
			boolean uspech=zpracuj(keKontrole, line, zasobnik);
			if(uspech){
				switch(stav){
				case 0:
					String[][] s=gramatika.get("porovnatelne");
					for(int i=0;i<s.length;++i)
						porovnatelne.add(s[i][0].substring(1));
					break;
				case 1:
					for(int i=0;i<promenne.length;++i)
						if(i==0)
							lokalInt+=promenne[i][0].substring(1);
						else
							lokalInt+=" "+promenne[i][0].substring(1);
					break;
				case 2:
					for(int i=0;i<promenne.length;++i)
						if(i==0)
							lokalString+=promenne[i][0].substring(1);
						else
							lokalString+=" "+promenne[i][0].substring(1);
					break;
				case 3:
					s=gramatika.get("globalInt");
					for(int i=0;i<s.length;++i)
						if(!s[i][0].equals("tpocethracu")&&!s[i][0].equals("ttah"))
							promenneInt.put(s[i][0].substring(1), 0);
					break;
				case 4:
					s=gramatika.get("globalString");
					for(int i=0;i<s.length;++i)
						promenneString.put(s[i][0].substring(1), "");
					break;
				case 5:
				case 6:
					prikazy.getFirst().set(0, neco+prikazy.getFirst().getFirst());
					break;
				case 7:
				case 8:
					lokalInt="";
					lokalString="";
					break;
				}
				return uspech;
			}
			else{
				if(chyba.isEmpty()){
					while(zasobnik.getLast().equals("m"))
						zasobnik.removeLast();
					if(zasobnik.getLast().equals("s6"))
						chyba="line "+line+": cislo expected";
					else if(zasobnik.getLast().equals("s5"))
						chyba="line "+line+": String expected";
					else
						chyba="line "+line+": "+zasobnik.getLast().substring(1)+" expected";
				}
				return uspech;
			}
		}
		else if(prvek.equals("m")){
			while(keKontrole.startsWith("\n")){
				++line;
				keKontrole=keKontrole.substring(1);
			}
			while(keKontrole.startsWith(" ")||keKontrole.startsWith("\t")){
				keKontrole=keKontrole.substring(1);
				while(keKontrole.startsWith("\n")){
					++line;
					keKontrole=keKontrole.substring(1);
				}
			}
			return zpracuj(keKontrole, line, zasobnik);
		}
		return true;
	}
}
