package inteligence;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.Socket;
import java.util.*;

import sit.Server;

import data.Informace;

/**
 * Tda k UI napsan uivatelem. Slou jako klient, kter podle UI zadan uivatelem simuluje hran hre.
 * @author Ondej Papk
 *
 */
public class UINapsana extends Thread{
	/**
	 * Program k vykonn.
	 */
	public LinkedList<LinkedList<LinkedList<String>>> program=new LinkedList<LinkedList<LinkedList<String>>>();
	/**
	 * Vstupn reader.
	 */
	BufferedReader in;
	/**
	 * Vstupn writer.
	 */
	PrintWriter out;
	/**
	 * Poet hr.
	 */
	int hracu;
	/**
	 * Kolikt je tento hr.
	 */
	int kolikaty;
	/**
	 * Stringov promnn.
	 */
	HashMap<String, String> promenneString=new HashMap<String, String>();
	/**
	 * Intov promnn.
	 */
	HashMap<String, Integer> promenneInt=new HashMap<String, Integer>();
	/**
	 * Slou k porovnvn string.
	 */
	LinkedList<String> porovnani=new LinkedList<String>();
	
	/**
	 * Konstruktor
	 * @param inf - informace o he
	 */
	public UINapsana(Informace inf){
		Automat automat=new Automat(true, inf);
		automat.vypocet(inf.getUI().getText().getText());
		program=automat.program;
		promenneInt=automat.promenneInt;
		promenneString=automat.promenneString;
		porovnani=Server.porovnani;
		this.start();
	}
	
	/**
	 * Metoda run tdy Thread. Pipoj se k serveru a ek ne se dostane na adu a potom odehraje.
	 */
	public void run(){
		Socket socket=null;
		try {
			InetAddress addr;
				addr=InetAddress.getByName(null);
			socket=new Socket(addr, 6666);
			in=new BufferedReader(new InputStreamReader(socket.getInputStream()));
			out=new PrintWriter(new OutputStreamWriter(socket.getOutputStream()), true);
			hracu=Integer.parseInt(in.readLine());
			kolikaty=Integer.parseInt(in.readLine());
			while(true){
				String s=in.readLine();
				if(s.equals("end"))
					break;
				else if(s.startsWith("next")&&Integer.parseInt(s.substring(s.indexOf(" ")+1))==kolikaty){
					Thread.sleep(500);
					proved(program.getLast());
				}
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
		}catch (NullPointerException e) {
			// TODO Auto-generated catch block
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
		} finally {
			try {
				in.close();
				out.close();
				socket.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
			}
		}
	}
	
	/**
	 * Provede zadan program. Jedn se o proveden UI napsan uivatelem.
	 * @param kProvedeni - program k proveden
	 */
	void proved(LinkedList<LinkedList<String>> kProvedeni){
		for(int i=0;i<kProvedeni.size();++i){
			String prikaz=kProvedeni.get(i).get(0);
			if(prikaz.equals("if"))
				if1(kProvedeni.get(i).get(1), Integer.parseInt(kProvedeni.get(i).get(2)), Integer.parseInt(kProvedeni.get(i).get(3)));
			else if(prikaz.equals("for"))
				for1(kProvedeni.get(i).get(1), kProvedeni.get(i).get(2), kProvedeni.get(i).get(3), Integer.parseInt(kProvedeni.get(i).get(4)));
			else if(prikaz.equals("klik"))
				klik(kProvedeni.get(i).get(1));
			else if(prikaz.equals("button"))
				button(kProvedeni.get(i).get(1));
			else if(prikaz.startsWith("show")){
				show(prikaz.substring(prikaz.indexOf(" ")+1));
			}
			else if(prikaz.equals("="))
				priradit(kProvedeni.get(i).get(2), kProvedeni.get(i).get(1));
		}
	}
	
	/**
	 * Provede if.
	 * @param podminka - podmnka ifu.
	 * @param splneno - index s pkazy k proveden pi splnn podmnky
	 * @param nesplneno - index s pkazy k proveden pi nesplnn podmnky
	 */
	void if1(String podminka, int splneno, int nesplneno){
		if(podminky(podminka, ""))
			proved(program.get(splneno));
		else if(nesplneno!=-1)
			proved(program.get(nesplneno));
	}
	
	/**
	 * Provede for cyklus
	 * @param promenna - promenn vyuvan ve for cyklu
	 * @param start - poten hodnota
	 * @param konec - koncov hodnota
	 * @param proved - index s pkazy k proveden
	 */
	void for1(String promenna, String start, String konec, int proved){
		int a=vypocty(start);
		int b=vypocty(konec);
		for(int i=a;i<b+1;++i){
				promenneInt.put(promenna, i);
				proved(program.get(proved));
		}
	}
	
	/**
	 * Zjiuje absolutn msto zadan relativn nebo hodnoty parametr karet.
	 * @param kde - msto
	 * @karta - karta, u kter se m zjiovat parametr
	 * @return msto nebo hodnotu
	 */
	String umisteno(String kde, String karta){
		StringTokenizer st=new StringTokenizer(kde, ".");
		String hrac=st.nextToken();
		if(hrac.equals("this"))
			hrac=((Integer)kolikaty).toString();
		else if(hrac.equals("stred"))
			hrac=((Integer)hracu).toString();
		else if(!karta.equals(""))
			return Server.karty.get(Integer.parseInt(karta)).get(hrac);
		else
			hrac=((Integer)vypocty(hrac)).toString();
		String misto=st.nextToken();
		if(!st.hasMoreTokens())
			return hrac+" "+misto;
		String co=st.nextToken();
		if(co.equals("first"))
			co=((Integer)Server.karty.indexOf(Server.umisteniKaret.get(Integer.parseInt(hrac)).get(misto).getFirst())).toString();
		else if(co.equals("last"))
			co=((Integer)Server.karty.indexOf(Server.umisteniKaret.get(Integer.parseInt(hrac)).get(misto).getLast())).toString();
		else if(co.startsWith("get"))
			co=((Integer)Server.karty.indexOf(Server.umisteniKaret.get(Integer.parseInt(hrac)).get(misto).get(vypocty(co.substring(co.indexOf("(")+1, co.length()-1))))).toString();
		else if(co.startsWith("contains")){
			while(st.hasMoreTokens())
				co+="."+st.nextToken();
			for(int i=0;i<Server.umisteniKaret.get(Integer.parseInt(hrac)).get(misto).size();++i){
				int a=Server.karty.indexOf(Server.umisteniKaret.get(Integer.parseInt(hrac)).get(misto).get(i));
				if(podminky(co.substring(9, co.length()-1), ((Integer)a).toString()))
					return "true";
			}
			return "false";
		}
		else if(co.startsWith("size"))
			return ((Integer)Server.umisteniKaret.get(Integer.parseInt(hrac)).get(misto).size()).toString();
		if(!st.hasMoreTokens())
			return hrac+" "+misto+" "+co;
		String parametr=st.nextToken();
		return Server.karty.get(Integer.parseInt(co)).get(parametr);
	}
	
	/**
	 * Vypote hodnotu vrazu zadanho parametrem.
	 * @param co - vraz k vypoten
	 * @return hodnota vrazu
	 */
	int vypocty(String co){
		while(co.contains("(")){
			int parovani=0;
			for(int i=co.indexOf("(");i<co.length();++i){
				if(co.charAt(i)=='(')
					++parovani;
				else if(co.charAt(i)==')')
					--parovani;
				if(parovani==0){
					parovani=i;
					break;
				}
			}
			String pred;
			String za;
			if(co.indexOf("(")==0)
				pred="";
			else
				pred=co.substring(0, co.indexOf("("));
			if(parovani==co.length()-1)
				za="";
			else
				za=co.substring(parovani+1);
			co=pred+vypocty(co.substring(co.indexOf("(")+1, parovani))+za;
		}
		if(co.contains("+")||co.contains("-"))
			if(co.indexOf("+")>co.indexOf("-"))
				return vypocty(co.substring(0, co.indexOf("+")))+vypocty(co.substring(co.indexOf("+")+1));
			else
				return vypocty(co.substring(0, co.indexOf("-")))-vypocty(co.substring(co.indexOf("-")+1));
		if(co.contains("*")||co.contains("/"))
			if(co.indexOf("*")>co.indexOf("/"))
				return vypocty(co.substring(0, co.indexOf("*")))*vypocty(co.substring(co.indexOf("*")+1));
			else
				return vypocty(co.substring(0, co.indexOf("/")))/vypocty(co.substring(co.indexOf("/")+1));
		if(co.contains("%"))
			return vypocty(co.substring(0, co.indexOf("%")))%vypocty(co.substring(co.indexOf("%")+1));
		if(promenneInt.containsKey(co))
			return promenneInt.get(co);
		else if(Server.promenneInt.containsKey(co))
			return Server.promenneInt.get(co);
		else if(co.equals("tah"))
			return kolikaty;
		else if(co.equals("pocethracu"))
			return hracu;
		else
			return Integer.parseInt(co);
	}
	
	/**
	 * Vyhodnot zadanou podmnku.
	 * @param co - podmnka ke zkontrolovn
	 * @param karta - karta, kter se kontroluje na contains
	 * @return true jestli podmnka plat, jinak false
	 */
	boolean podminky(String co, String karta){
		StringTokenizer and=new StringTokenizer(co, "&&");
		boolean vnejsi=true;
		while(and.hasMoreTokens()){
			StringTokenizer or=new StringTokenizer(and.nextToken(), "||");
			boolean vnitrni=false;
			while(or.hasMoreTokens()){
				String cele=or.nextToken();
				boolean negace=false;
				if(cele.startsWith("not ")){
					negace=true;
					cele=cele.substring(4);
				}
				String a;
				String b;
				int operator;
				if(cele.contains("contains(")){
					int pocet=0;
					for(int i=9;i<cele.length();++i){
						if(cele.charAt(i)=='(')
							++pocet;
						else if(cele.charAt(i)==')')
							--pocet;
						if(pocet!=0&&i==cele.length()-1){
							if(!or.hasMoreTokens()){
								cele+="&&";
								or=new StringTokenizer(and.nextToken(), "||");
								cele+=or.nextToken();
							}
							else
								cele+="||"+or.nextToken();
						}
					}
					if(umisteno(cele, "").equals("true"))
						return true;
					else
						return false;
				}
				else if(cele.contains("=")){
					StringTokenizer operatory=new StringTokenizer(cele, "=");
					a=operatory.nextToken();
					b=operatory.nextToken();
					operator=0;
				}
				else if(cele.contains("<")){
					StringTokenizer operatory=new StringTokenizer(cele, "<");
					a=operatory.nextToken();
					b=operatory.nextToken();
					operator=1;
				}
				else{
					StringTokenizer operatory=new StringTokenizer(cele, ">");
					a=operatory.nextToken();
					b=operatory.nextToken();
					operator=2;
				}
				if(!karta.equals("")&&Server.karty.get(Integer.parseInt(karta)).containsKey(a))
					a=umisteno(a, karta);
				else if(a.contains("."))
					a=umisteno(a, "");
				else if(a.contains("\""))
					a=a.substring(1, a.length()-1);
				else if(promenneString.containsKey(a))
					a=promenneString.get(a);
				else if(Server.promenneString.containsKey(a))
					a=Server.promenneString.get(a);
				else
					a=((Integer)vypocty(a)).toString();
				if(!karta.equals("")&&Server.karty.get(Integer.parseInt(karta)).containsKey(b))
					b=umisteno(b, karta);
				else if(b.contains("."))
					b=umisteno(b, "");
				else if(b.contains("\""))
					b=b.substring(1, b.length()-1);
				else if(promenneString.containsKey(b))
					b=promenneString.get(b);
				else if(Server.promenneString.containsKey(b))
					b=Server.promenneString.get(b);
				else
					b=((Integer)vypocty(b)).toString();
				if(operator==0){
					if(a.equals(b))
						vnitrni=true;
				}
				else if(operator==1){
					if(porovnani.contains(a)){
						if(porovnani.indexOf(a)<porovnani.indexOf(b))
							vnitrni=true;
					}
					else{
						if(Integer.parseInt(a)<Integer.parseInt(b))
							vnitrni=true;
					}
				}
				else{
					if(porovnani.contains(a)){
						if(porovnani.indexOf(a)>porovnani.indexOf(b))
							vnitrni=true;
					}
					else{
						if(Integer.parseInt(a)>Integer.parseInt(b))
							vnitrni=true;
					}
				}
				if(negace)
					if(vnitrni)
						vnitrni=false;
					else
						vnitrni=true;
				if(vnitrni)
					break;
			}
			if(!vnitrni){
				vnejsi=false;
				break;
			}
		}
		if(vnejsi)
			return true;
		else
			return false;
	}
	
	/**
	 * Piad hodnotu do promnn.
	 * @param co - hodnota k piazen
	 * @param kam - promnn, do kter se piazuje
	 */
	void priradit(String co, String kam){
		String s;
		if(co.contains("\""))
			s=co.substring(1, co.length()-1);
		else if(co.contains("."))
			s=umisteno(co, "");
		else if(promenneString.containsKey(co))
			s=promenneString.get(co);
		else if(Server.promenneString.containsKey(co))
			s=Server.promenneString.get(co);
		else
			s=((Integer)vypocty(co)).toString();
		if(promenneString.containsKey(kam))
			promenneString.put(kam, s);
		else if(promenneInt.containsKey(kam))
			promenneInt.put(kam, Integer.parseInt(s));
	}
	
	/**
	 * Simuluje kliknut na kartu.
	 * @param co - karta, na kterou se kliklo
	 */
	void klik(String co){
		co=umisteno(co, "");
		out.println("klik "+co);
	}
	
	/**
	 * Simuluje kliknut na tlatko na danm mst.
	 * @param misto - msto s tlatkem
	 */
	void button(String misto){
		misto=umisteno(misto, "");
		out.println("but "+misto);
	}
	
	/**
	 * Simujuje vybrn hodnoty.
	 * @param co - vybran hodnota
	 */
	void show(String co){
		if(co.startsWith("\""))
			co=co.substring(1, co.length()-1);
		else if(promenneString.containsKey(co))
			co=promenneString.get(co);
		else if(promenneInt.containsKey(co))
			co=((Integer)promenneInt.get(co)).toString();
		else if(Server.promenneString.containsKey(co))
			co=Server.promenneString.get(co);
		else if(Server.promenneInt.containsKey(co))
			co=((Integer)Server.promenneInt.get(co)).toString();
		else
			co=umisteno(co, "");
		out.println(co);
	}
}
