package inteligence;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.Socket;
import java.util.*;

import sit.Server;

import data.Informace;

public class UIUniverzalni extends Thread{
	
	/**
	 * Reprezentuje jednu kartu.
	 * @author Ondej Papk
	 *
	 */
	class Karta{
		/**
		 * Parametry karty.
		 */
		HashMap<String,String> parametry=new HashMap<String,String>();
		/**
		 * Informace zda je karta hri znm. 
		 */
		boolean znama=false;
	}
	
	/**
	 * Stav, ve kterm se hra nachz.
	 * @author Ondej Papk
	 *
	 */
	class Stav{
		/**
		 * Pozice karet, tlatek a label. Jedn se o seznam hr, kde u kadho hre je HashMapa, kde klem je nzev msta a 
		 * hodnotou je seznam karet. Karty jsou zadny jako indexy do balku. Kdy je index -1 resp -2, tak se na danm mst nachz 
		 * button resp. label.
		 */
		LinkedList<HashMap<String, LinkedList<Integer>>> pozice;
		/**
		 * Globln Stringov promnn.
		 */
		HashMap<String, String> promenneString;
		/**
		 * Globln intov promnn.
		 */
		HashMap<String, Integer> promenneInt;
		/**
		 * Lokln Stringov promnn.
		 */
		HashMap<String, String> lokalString;
		/**
		 * Lokln intov promnn.
		 */
		HashMap<String, Integer> lokalInt;
		/**
		 * Informace o tom, kter hr je na ad.
		 */
		int naRade;
		/**
		 * Akce, ktermi vznikl tento uzel.
		 */
		LinkedList<String> akce=new LinkedList<String>();
		/**
		 * Vektor hodnot spotan minimaxem.
		 */
		int[] hodnota;
		/**
		 * Poet sourozenc ve strom na rznch hladinch.
		 */
		LinkedList<Integer> sourozenci=new LinkedList<Integer>();
		/**
		 * Konstruktor
		 */
		Stav(){
			naRade=kolikaty;
			pozice=new LinkedList<HashMap<String, LinkedList<Integer>>>();
			promenneInt=new HashMap<String, Integer>();
			promenneString=new HashMap<String, String>();
			lokalInt=new HashMap<String, Integer>();
			lokalString=new HashMap<String, String>();
			for(int i=0;i<pocetHracu;++i){
				pozice.add(new HashMap<String, LinkedList<Integer>>());
				for(int j=0;j<informace.getVzhled().getNazevHrac().size();++j){
					pozice.get(i).put(informace.getVzhled().getNazevHrac().get(j).getText(), new LinkedList<Integer>());
				}
			}
			pozice.add(new HashMap<String, LinkedList<Integer>>());
			for(int j=0;j<informace.getVzhled().getNazevStred().size();++j){
				pozice.get(pocetHracu).put(informace.getVzhled().getNazevStred().get(j).getText(), new LinkedList<Integer>());
			}
			for(int hrac=0;hrac<pozice.size();++hrac)
				for(String misto:pozice.get(hrac).keySet())
					for(int i=0;i<Server.umisteniKaret.get(hrac).get(misto).size();++i)
						pozice.get(hrac).get(misto).add(Server.karty.indexOf(Server.umisteniKaret.get(hrac).get(misto).get(i)));
		}
		/**
		 * Konstruktor, kter vytvo kopii podle parametru.
		 * @param st - stav ke zkoprovn
		 * @param ak - akce, kter vytvo tento stav
		 */
		Stav(Stav st, String ak){
			pozice=new LinkedList<HashMap<String, LinkedList<Integer>>>();
			for(int i=0;i<st.pozice.size();++i){
				pozice.add(new HashMap<String, LinkedList<Integer>>());
				for(String misto:st.pozice.get(i).keySet()){
					pozice.get(i).put(misto, new LinkedList<Integer>());
					for(int j=0;j<st.pozice.get(i).get(misto).size();++j){
						pozice.get(i).get(misto).add(st.pozice.get(i).get(misto).get(j));
					}
				}
			}
			promenneInt=new HashMap<String, Integer>();
			for(String i:st.promenneInt.keySet())
				promenneInt.put(i, st.promenneInt.get(i));
			promenneString=new HashMap<String, String>();
			for(String i:st.promenneString.keySet())
				promenneString.put(i, st.promenneString.get(i));
			lokalInt=new HashMap<String, Integer>();
			for(String i:st.lokalInt.keySet())
				lokalInt.put(i, st.lokalInt.get(i));
			lokalString=new HashMap<String, String>();
			for(String i:st.lokalString.keySet())
				lokalString.put(i, st.lokalString.get(i));
			for(String i:st.akce)
				akce.add(i);
			akce.add(ak);
			naRade=st.naRade;
		}
	}
	
	/**
	 * Balek vech karet.
	 */
	LinkedList<Karta> balicek;
	/**
	 * Hlaviky pravidel.
	 */
	HashMap<String[], Integer> hlavicky;
	/**
	 * Program k vykonn.
	 */
	LinkedList<LinkedList<LinkedList<String>>> program;
	/**
	 * M hodnotu ture, pokud jsou karty v dan lokaci na sob.
	 */
	LinkedList<HashMap<String, Boolean>> naSobe;
	/**
	 * Slou k porovnvn string.
	 */
	LinkedList<String> porovnani=new LinkedList<String>();
	/**
	 * Stav, ve kterm se aktuln nachz hra.
	 */
	Stav aktualniStav;
	/**
	 * Poet hr ve he.
	 */
	int pocetHracu;
	/**
	 * Vstupn reader.
	 */
	BufferedReader in;
	/**
	 * Vstupn writer.
	 */
	PrintWriter out;
	/**
	 * Kolikt je tento hr.
	 */
	int kolikaty;
	/**
	 * Uruje, zda m pota odpovdat na dotazy.
	 */
	boolean aktivni=false;
	/**
	 * Stav, kter obsahuje odpovdi na dotazy.
	 */
	Stav aktivniStav;
	/**
	 * Informace o he.
	 */
	Informace informace;
	
	/**
	 * Konstruktor pro vytvoen klienta.
	 * @param inf informace o he
	 * @param pocet poet hrajcch hr
	 * @param hlav hlaviky pravidel
	 * @param prog pravidla
	 * @param porov seznam k porovnvn String
	 */
	public UIUniverzalni(Informace inf, int pocet, HashMap<String[], Integer> hlav, LinkedList<LinkedList<LinkedList<String>>> prog, LinkedList<String> porov){
		pocetHracu=pocet;
		hlavicky=hlav;
		program=prog;
		porovnani=porov;
		informace=inf;
		aktualniStav=new Stav();
		balicek=new LinkedList<Karta>();
		for(int i=0;i<inf.getKarty().getZvolena().getItemCount();++i)
			for(int j=0;j<Integer.parseInt(inf.getKarty().getPocty().get(inf.getKarty().getZvolena().getItemAt(i))[0].getText());++j){
				Karta card=new Karta();
				for(String parametr:inf.getKarty().getSeznamParametru())
					card.parametry.put(parametr, inf.getKarty().getParametry().get(inf.getKarty().getZvolena().getItemAt(i)).get(parametr).getText());
				balicek.add(card);
			}
		naSobe=new LinkedList<HashMap<String, Boolean>>();
		for(int i=0;i<pocetHracu;++i){
			naSobe.add(new HashMap<String, Boolean>());
			for(int j=0;j<inf.getVzhled().getNazevHrac().size();++j){
				naSobe.get(i).put(inf.getVzhled().getNazevHrac().get(j).getText(), inf.getVzhled().getVerejneHrac().get(j*5+4).isSelected());
			}
		}
		naSobe.add(new HashMap<String, Boolean>());
		for(int j=0;j<inf.getVzhled().getNazevStred().size();++j){
			naSobe.get(pocetHracu).put(inf.getVzhled().getNazevStred().get(j).getText(), inf.getVzhled().getVerejneStred().get(j*4+3).isSelected());
		}
		this.start();
	}
	
	/**
	 * Metoda run tdy Thread. Propoj klienta se Serverem.
	 */
	public void run() {
		Socket socket=null;
		try {
			InetAddress addr;
				addr=InetAddress.getByName(null);
			socket=new Socket(addr, 6666);
			in=new BufferedReader(new InputStreamReader(socket.getInputStream()));
			out=new PrintWriter(new OutputStreamWriter(socket.getOutputStream()), true);
			in.readLine();
			kolikaty=Integer.parseInt(in.readLine());
			aktualniStav.naRade=kolikaty;
			while(true){
				String s=in.readLine();
				if(s.equals("end"))
					break;
				else{
					aktualizuj(s);
				}
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
		} catch (NullPointerException e) {
			// TODO Auto-generated catch block
		} finally {
			try {
				in.close();
				out.close();
				socket.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
			}
		}
	}
	
	/**
	 * Aktualizuje aktualni stav hry podle prichoziho prikazu nebo pokud je hr na ad, tak odehraje.
	 * @param prikaz - pkaz k proveden
	 */
	void aktualizuj(String prikaz){
		StringTokenizer radek=new StringTokenizer(prikaz);
		String aktivita=radek.nextToken();
		if(aktivita.equals("ins")){
			final int hrac=Integer.parseInt(radek.nextToken());
			final String misto=radek.nextToken();
			String co=radek.nextToken();
			if(co.equals("lab")){
				aktualniStav.pozice.get(hrac).get(misto).add(-2);
			}
			else if(co.equals("but")){
				aktualniStav.pozice.get(hrac).get(misto).add(-1);
			}
			else{
				final int karta=Integer.parseInt(co);
				aktualniStav.pozice.get(hrac).get(misto).add(karta);
				if(radek.nextToken().equals("true"))
					balicek.get(karta).znama=true;
			}
		}
		else if(aktivita.equals("del")){
			int hrac=Integer.parseInt(radek.nextToken());
			String misto=radek.nextToken();
			String co=radek.nextToken();
			if(co.equals("lab")||co.equals("but")){
				aktualniStav.pozice.get(hrac).put(misto, new LinkedList<Integer>());
			}
			else{
				int karta=Integer.parseInt(co);
				for(int i=0;i<aktualniStav.pozice.get(hrac).get(misto).size();++i){
					if(aktualniStav.pozice.get(hrac).get(misto).get(i).equals(karta)){
						aktualniStav.pozice.get(hrac).get(misto).remove(i);
						break;
					}
				}
			}
		}
		else if(aktivita.equals("next")){
			if(Integer.parseInt(radek.nextToken())==kolikaty){
				aktivni=true;
				aktualniStav=new Stav();
				out.println(zacatek(5));
				aktivniStav.akce.removeFirst();
				aktivniStav.akce.removeFirst();
				while(aktivniStav.akce.size()>0&&aktivniStav.akce.getFirst().equals("shuffle"))
					aktivniStav.akce.removeFirst();
			}
			else
				aktivni=false;
		}
		else if(aktivita.equals("show")){
			if(aktivni)
				if(aktivniStav.akce.size()>0){
					String co=null;
					while(radek.hasMoreTokens()){
						co=radek.nextToken();
						if(co.equals(aktivniStav.akce.getFirst())){
							aktivniStav.akce.removeFirst();
							while(aktivniStav.akce.size()>0&&aktivniStav.akce.getFirst().equals("shuffle"))
								aktivniStav.akce.removeFirst();
							out.println(co);
							return;
						}
					}
					out.println(co);
				}
				else{
					out.println(radek.nextToken());
				}
		}
		else if(aktivita.equals("shuffle")){
			int karta=Integer.parseInt(radek.nextToken());
			balicek.get(karta).znama=false;
		}
	}
	
	String zacatek(int hloubka){
		aktualniStav.promenneInt=Server.promenneInt;
		aktualniStav.promenneString=Server.promenneString;
		LinkedList<Integer> seznam=new LinkedList<Integer>();
		for(int i=0;i<aktualniStav.pozice.size();++i){
			for(String misto:aktualniStav.pozice.get(i).keySet()){
				for(int j=0;j<aktualniStav.pozice.get(i).get(misto).size();++j){
					if(!balicek.get(aktualniStav.pozice.get(i).get(misto).get(j)).znama)
						seznam.add(aktualniStav.pozice.get(i).get(misto).get(j));
				}
			}
		}
		HashMap<String, Integer> hodnoty=new HashMap<String, Integer>();
		LinkedList<Stav> stavy=new LinkedList<Stav>();
		for(int k=0;k<100;++k){
			LinkedList<Integer> novySeznam=new LinkedList<Integer>();
			for(int j=0;j<seznam.size();++j){
				novySeznam.add(seznam.get(j));
			}
			Stav stav=rozmichat(aktualniStav, novySeznam);
			for(int i=0;i<stav.pozice.size();++i){
				for(String misto:stav.pozice.get(i).keySet()){
					for(int j=stav.pozice.get(i).get(misto).size()-1;j>-1;--j){
						if(!stav.pozice.get(i).get(misto).get(j).equals(-1)&&!stav.pozice.get(i).get(misto).get(j).equals(-2)){
							int karta=stav.pozice.get(i).get(misto).get(j);
							LinkedList<LinkedList<String>> metoda=null;
							HashMap<String, String> lokalString=null;
							HashMap<String, Integer> lokalInt=null;
							int priorita=-1;
							for(String[] key:hlavicky.keySet()){
								if(key[0].equals("klik")&&key[2].equals(misto)&&((key[1].equals("this")&&i==stav.naRade)||
										(key[1].equals("other")&&i!=stav.naRade)||(key[1].equals("stred")&&i==pocetHracu)||
										(key[1].equals("all")&&i<pocetHracu))){
									if(Integer.parseInt(key[3])>priorita&&(key[4].equals("all")||podminky(key[4], i+" "+misto+" "+karta, new Stav(stav, "")))){
										priorita=Integer.parseInt(key[3]);
										metoda=program.get(hlavicky.get(key));
										lokalString=new HashMap<String, String>();
										lokalInt=new HashMap<String, Integer>();
										StringTokenizer st=new StringTokenizer(key[5]);
										while(st.hasMoreTokens())
											lokalString.put(st.nextToken(), "");
										st=new StringTokenizer(key[6]);
										while(st.hasMoreTokens())
											lokalInt.put(st.nextToken(), 0);
									}
								}
							}
							if(metoda!=null){
								LinkedList<Stav> vsechno=proved(metoda, i+" "+misto+" "+karta, new Stav(stav, "klik "+i+" "+misto+" "+j));
								for(int l=0;l<vsechno.size();++l){
									vsechno.get(l).hodnota=minimax(hloubka-1, vsechno.get(l));
									vsechno.get(l).sourozenci.addFirst(1);
								}
								if(!hodnoty.containsKey("klik "+i+" "+misto+" "+j))
									hodnoty.put("klik "+i+" "+misto+" "+j, 0);
								stavy.add(uprava(vsechno));
								hodnoty.put("klik "+i+" "+misto+" "+j, hodnoty.get("klik "+i+" "+misto+" "+j)+stavy.getLast().hodnota[kolikaty]);
							}
						}
						else if(stav.pozice.get(i).get(misto).get(j).equals(-1)){
							LinkedList<LinkedList<String>> metoda=null;
							HashMap<String, String> lokalString=null;
							HashMap<String, Integer> lokalInt=null;
							for(String[] key:hlavicky.keySet()){
								if(key[0].equals("button")&&key[2].equals(misto)&&((key[1].equals("this")&&i==stav.naRade)||
										(key[1].equals("other")&&i!=stav.naRade)||(key[1].equals("stred")&&i==pocetHracu)||
										(key[1].equals("all")&&i<pocetHracu))){
									metoda=program.get(hlavicky.get(key));
									lokalString=new HashMap<String, String>();
									lokalInt=new HashMap<String, Integer>();
									StringTokenizer st=new StringTokenizer(key[3]);
									while(st.hasMoreTokens())
										lokalString.put(st.nextToken(), "");
									st=new StringTokenizer(key[4]);
									while(st.hasMoreTokens())
										lokalInt.put(st.nextToken(), 0);
								}
							}
							if(metoda!=null){
								LinkedList<Stav> vsechno=proved(metoda, "", new Stav(stav, "button "+i+" "+misto));
								for(int l=0;l<seznam.size();++l){
									vsechno.get(l).hodnota=minimax(hloubka-1, vsechno.get(l));
									vsechno.get(l).sourozenci.addFirst(1);
								}
								if(!hodnoty.containsKey("button "+i+" "+misto))
									hodnoty.put("button "+i+" "+misto, 0);
								stavy.add(uprava(vsechno));
								hodnoty.put("button "+i+" "+misto, hodnoty.get("button "+i+" "+misto)+stavy.getLast().hodnota[kolikaty]);
							}
						}
						if(naSobe.get(i).get(misto))
							break;
					}
				}
			}
		}
		String s="";
		int cislo=0;
		for(String key:hodnoty.keySet())
			if(s==""){
				cislo=hodnoty.get(key);
				s=key;
			}
			else if(cislo<hodnoty.get(key)){
				cislo=hodnoty.get(key);
				s=key;
			}
		int index=-1;
		for(int i=0;i<stavy.size();++i)
			if(stavy.get(i).akce.get(1).equals(s))
				if(index==-1)
					index=i;
				else if(stavy.get(i).hodnota[kolikaty]>stavy.get(index).hodnota[kolikaty])
					index=i;
		aktivniStav=stavy.get(index);
		StringTokenizer st=new StringTokenizer(s);
		String akce=st.nextToken();
		if(akce.equals("button"))
			return s;
		else{
			int hrac=Integer.parseInt(st.nextToken());
			String misto=st.nextToken();
			int karta=Integer.parseInt(st.nextToken());
			karta=aktualniStav.pozice.get(hrac).get(misto).get(karta);
			s="klik "+hrac+" "+misto+" "+karta;
			return s;
		}
	}
	
	int[] minimax(int hloubka, Stav stav){
		for(String[] i:hlavicky.keySet())
			if(i[0].equals("konec")){
				HashMap<String, String> lokalString=new HashMap<String, String>();
				HashMap<String, Integer> lokalInt=new HashMap<String, Integer>();
				StringTokenizer st=new StringTokenizer(i[1]);
				while(st.hasMoreTokens())
					lokalString.put(st.nextToken(), "");
				st=new StringTokenizer(i[2]);
				while(st.hasMoreTokens())
					lokalInt.put(st.nextToken(), 0);
				stav.lokalInt=lokalInt;
				stav.lokalString=lokalString;
				LinkedList<Stav> seznam=proved(program.get(hlavicky.get(i)), "", stav);
				if(seznam.get(0).lokalString.get("konec").equals("true")||hloubka==0){
					int[] vysledek=new int[pocetHracu];
					for(int j=0;j<pocetHracu;++j)
						vysledek[j]=seznam.get(0).lokalInt.get("h"+j);
					return vysledek;
				}
				break;
			}
		LinkedList<Stav> vsechno=new LinkedList<Stav>();
		int pocet=0;
		for(int i=0;i<stav.pozice.size();++i){
			for(String misto:stav.pozice.get(i).keySet()){
				for(int j=stav.pozice.get(i).get(misto).size()-1;j>-1;--j){
					if(!stav.pozice.get(i).get(misto).get(j).equals(-1)&&!stav.pozice.get(i).get(misto).get(j).equals(-2)){
						int karta=stav.pozice.get(i).get(misto).get(j);
						LinkedList<LinkedList<String>> metoda=null;
						HashMap<String, String> lokalString=null;
						HashMap<String, Integer> lokalInt=null;
						int priorita=-1;
						for(String[] key:hlavicky.keySet()){
							if(key[0].equals("klik")&&key[2].equals(misto)&&((key[1].equals("this")&&i==stav.naRade)||
									(key[1].equals("other")&&i!=stav.naRade)||(key[1].equals("stred")&&i==pocetHracu)||
									(key[1].equals("all")&&i<pocetHracu))){
								if(Integer.parseInt(key[3])>priorita&&(key[4].equals("all")||podminky(key[4], i+" "+misto+" "+karta, new Stav(stav, "")))){
									priorita=Integer.parseInt(key[3]);
									metoda=program.get(hlavicky.get(key));
									lokalString=new HashMap<String, String>();
									lokalInt=new HashMap<String, Integer>();
									StringTokenizer st=new StringTokenizer(key[5]);
									while(st.hasMoreTokens())
										lokalString.put(st.nextToken(), "");
									st=new StringTokenizer(key[6]);
									while(st.hasMoreTokens())
										lokalInt.put(st.nextToken(), 0);
								}
							}
						}
						if(metoda!=null){
							Stav kopie=new Stav(stav, "klik "+i+" "+misto+" "+karta);
							kopie.sourozenci=new LinkedList<Integer>();
							kopie.akce=new LinkedList<String>();
							kopie.akce.add("klik "+i+" "+misto+" "+karta);
							LinkedList<Stav> seznam=proved(metoda, i+" "+misto+" "+karta, kopie);
							for(int k=0;k<seznam.size();++k)
								seznam.get(k).hodnota=minimax(hloubka-1, seznam.get(k));
							vsechno.addAll(seznam);
							++pocet;
						}
					}
					else if(stav.pozice.get(i).get(misto).get(j).equals(-1)){
						LinkedList<LinkedList<String>> metoda=null;
						HashMap<String, String> lokalString=null;
						HashMap<String, Integer> lokalInt=null;
						for(String[] key:hlavicky.keySet()){
							if(key[0].equals("button")&&key[2].equals(misto)&&((key[1].equals("this")&&i==stav.naRade)||
									(key[1].equals("other")&&i!=stav.naRade)||(key[1].equals("stred")&&i==pocetHracu)||
									(key[1].equals("all")&&i<pocetHracu))){
								metoda=program.get(hlavicky.get(key));
								lokalString=new HashMap<String, String>();
								lokalInt=new HashMap<String, Integer>();
								StringTokenizer st=new StringTokenizer(key[3]);
								while(st.hasMoreTokens())
									lokalString.put(st.nextToken(), "");
								st=new StringTokenizer(key[4]);
								while(st.hasMoreTokens())
									lokalInt.put(st.nextToken(), 0);
							}
						}
						if(metoda!=null){
							Stav kopie=new Stav(stav, "button "+i+" "+misto);
							kopie.sourozenci=new LinkedList<Integer>();
							kopie.akce=new LinkedList<String>();
							kopie.akce.add("button "+i+" "+misto);
							LinkedList<Stav> seznam=proved(metoda, "", kopie);
							for(int k=0;k<seznam.size();++k)
								seznam.get(k).hodnota=minimax(hloubka-1, seznam.get(k));
							vsechno.addAll(seznam);
							++pocet;
						}
					}
					if(naSobe.get(i).get(misto))
						break;
				}
			}
		}
		for(int i=0;i<vsechno.size();++i)
			vsechno.get(i).sourozenci.addFirst(pocet);
		return uprava(vsechno).hodnota;
	}
	
	Stav uprava(LinkedList<Stav> vsechno){
		int hloubka=0;
		for(int i=0;i<vsechno.size();++i)
			if(hloubka<vsechno.get(i).sourozenci.size())
				hloubka=vsechno.get(i).sourozenci.size();
		for(int i=hloubka-1;i>-1;--i)
			for(int j=0;j<vsechno.size();++j)
				if(vsechno.get(j).sourozenci.size()>i)
					if(vsechno.get(j).akce.get(i).equals("shuffle")){
						int konec=vsechno.get(j).sourozenci.get(i);
						for(int k=1;k<konec;++k){
							for(int l=0;l<pocetHracu;++l)
								vsechno.get(j).hodnota[l]+=vsechno.get(j+1).hodnota[l];
							vsechno.remove(j+1);
						}
						for(int l=0;l<pocetHracu;++l)
							vsechno.get(j).hodnota[l]/=konec;
					}
					else{
						int konec=vsechno.get(j).sourozenci.get(i);
						for(int k=1;k<konec;++k)
							if(vsechno.get(j).hodnota[vsechno.get(j).naRade]<vsechno.get(j+1).hodnota[vsechno.get(j+1).naRade])
								vsechno.remove(j);
							else
								vsechno.remove(j+1);
					}
		return vsechno.get(0);
	}
	
	Stav rozmichat(Stav st, LinkedList<Integer> seznam){
		Stav stav=new Stav(st, "");
		for(int i=0;i<st.pozice.size();++i){
			for(String misto:st.pozice.get(i).keySet()){
				for(int j=0;j<st.pozice.get(i).get(misto).size();++j){
					if(!balicek.get(st.pozice.get(i).get(misto).get(j)).znama)
						stav.pozice.get(i).get(misto).set(j, seznam.remove((new Random()).nextInt(seznam.size())));
				}
			}
		}
		return stav;
	}
	
	/**
	 * Provede zadan pkazy.
	 * @param radky - seznam pkaz s parametry
	 * @param tahle - aktuln karta
	 * @param stav - stav, ve kterm se nachz hra
	 * @return seznam stav, ve kterch se me hra nachzet po vykonn zadanho programu
	 */
	LinkedList<Stav> proved(LinkedList<LinkedList<String>> radky, String tahle, Stav stav){
		LinkedList<Stav> vysledek=new LinkedList<Stav>();
		vysledek.add(stav);
		for(int i=0;i<radky.size();++i){
			String prikaz=radky.get(i).get(0);
			if(prikaz.equals("move")){
				move(radky.get(i).get(1), radky.get(i).get(2), tahle, stav);
			}
			else if(prikaz.equals("if")){
				LinkedList<Stav> seznam=if1(radky.get(i).get(1), Integer.parseInt(radky.get(i).get(2)), Integer.parseInt(radky.get(i).get(3)), tahle, stav);
				LinkedList<LinkedList<String>> zbytek=new LinkedList<LinkedList<String>>();
				for(int j=i+1;j<radky.size();++j)
					zbytek.add(radky.get(j));
				vysledek=new LinkedList<Stav>();
				for(int j=0;j<seznam.size();++j)
					vysledek.addAll(proved(zbytek, tahle, seznam.get(j)));
				return vysledek;
			}
			else if(prikaz.equals("for")){
				LinkedList<Stav> seznam=for1(radky.get(i).get(1), vypocty(radky.get(i).get(2), stav), vypocty(radky.get(i).get(3), stav), Integer.parseInt(radky.get(i).get(4)), tahle, stav);
				LinkedList<LinkedList<String>> zbytek=new LinkedList<LinkedList<String>>();
				for(int j=i+1;j<radky.size();++j)
					zbytek.add(radky.get(j));
				vysledek=new LinkedList<Stav>();
				for(int j=0;j<seznam.size();++j)
					vysledek.addAll(proved(zbytek, tahle, seznam.get(j)));
				return vysledek;
			}
			else if(prikaz.equals("next")){
				next(radky.get(i).get(1), stav);
			}
			else if(prikaz.equals("button")){
				if(radky.get(i).size()==2)
					button(radky.get(i).get(1), tahle, stav);
				else
					button(radky.get(i).get(1), radky.get(i).get(2), tahle, stav);
			}
			else if(prikaz.equals("shuffle")){
				LinkedList<LinkedList<String>> zbytek=new LinkedList<LinkedList<String>>();
				for(int j=i+1;j<radky.size();++j)
					zbytek.add(radky.get(j));
				vysledek=new LinkedList<Stav>();
				for(int j=0;j<100;++j){
					Stav st=new Stav(stav, "shuffle");
					st.sourozenci.add(100);
					zamichat(radky.get(i).get(1), radky.get(i).get(2), tahle, st);
					vysledek.addAll(proved(zbytek, tahle, st));
				}
				return vysledek;
			}
			else if(prikaz.equals("=")){
				String co=radky.get(i).get(2);
				if(co.startsWith("show")){
					co=co.substring(co.indexOf(" ")+1);
					StringTokenizer st=new StringTokenizer(co);
					int pocet=st.countTokens();
					LinkedList<LinkedList<String>> zbytek=new LinkedList<LinkedList<String>>();
					for(int j=i+1;j<radky.size();++j)
						zbytek.add(radky.get(j));
					vysledek=new LinkedList<Stav>();
					while(st.hasMoreTokens()){
						co=st.nextToken();
						if(co.contains("\""))
							co=co.substring(1, co.length()-1);
						else if(co.contains(".")||(!tahle.equals("")&&stav.pozice.get(Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1))).containsKey(co)))
							co=umisteno(co, tahle, stav);
						else if(stav.lokalString.containsKey(co))
							co=stav.lokalString.get(co);
						else if(stav.promenneString.containsKey(co))
							co=stav.promenneString.get(co);
						else
							co=((Integer)vypocty(co, stav)).toString();
						Stav novy=new Stav(stav, co);
						novy.sourozenci.add(pocet);
						co="\""+co+"\"";
						priradit(co, radky.get(i).get(1), tahle, novy);
						vysledek.addAll(proved(zbytek, tahle, novy));
					}
					return vysledek;
				}
				else
					priradit(radky.get(i).get(2), radky.get(i).get(1), tahle, stav);
			}
		}
		return vysledek;
	}
	
	/**
	 * Pesune karty.
	 * @param co - karta/y k pesunu
	 * @param kam - umstn karet
	 * @param tahle - aktuln karta
	 * @param stav - stav, ve kterm se nachz hra
	 */
	void move(String co, String kam, String tahle, Stav stav){
		StringTokenizer st=new StringTokenizer(umisteno(kam, tahle, stav));
		int kamHrac=Integer.parseInt(st.nextToken());
		String kamMisto=st.nextToken();
		if(stav.pozice.get(kamHrac).get(kamMisto).size()>0&&(stav.pozice.get(kamHrac).get(kamMisto).get(0)==-1||stav.pozice.get(kamHrac).get(kamMisto).get(0)==-2))
			return;
		st=new StringTokenizer(umisteno(co, tahle, stav));
		int odHrac=Integer.parseInt(st.nextToken());
		String odMisto=st.nextToken();
		LinkedList<Integer> odCo=new LinkedList<Integer>();
		if(st.hasMoreTokens())
			odCo.add(Integer.parseInt(st.nextToken()));
		else
			for(int i=0;i<stav.pozice.get(odHrac).get(odMisto).size();++i)
				odCo.add(stav.pozice.get(odHrac).get(odMisto).get(i));
		for(int i=odCo.size()-1;i>-1;--i){
			stav.pozice.get(odHrac).get(odMisto).remove(odCo.get(i));
			stav.pozice.get(kamHrac).get(kamMisto).add(odCo.get(i));
		}
	}
	
	/**
	 * Provede if.
	 * @param podminka - podmnka ifu.
	 * @param splneno - index s pkazy k proveden pi splnn podmnky
	 * @param nesplneno - index s pkazy k proveden pi nesplnn podmnky
	 * @param tahle - aktuln karta
	 * @param stav - stav, ve kterm se nachz hra
	 * @return seznam stav, ve kterch se me hra nachzet po vykonn ifu
	 */
	LinkedList<Stav> if1(String podminka, int splneno, int nesplneno, String tahle, Stav stav){
		if(podminky(podminka, tahle, stav))
			return proved(program.get(splneno), tahle, stav);
		else if(nesplneno!=-1)
			return proved(program.get(nesplneno), tahle, stav);
		else{
			LinkedList<Stav> vysledek=new LinkedList<Stav>();
			vysledek.add(stav);
			return vysledek;
		}
	}
	
	/**
	 * Provede for cyklus
	 * @param promenna - promenn vyuvan ve for cyklu
	 * @param start - poten hodnota
	 * @param konec - koncov hodnota
	 * @param proved - index s pkazy k proveden
	 * @param tahle - aktuln karta
	 * @param stav - stav, ve kterm se hra nachz
	 * @return seznam stav, ve kterch se me hra nachzet po vykonn foru
	 */
	LinkedList<Stav> for1(String promenna, int start, int konec, int proved, String tahle, Stav stav){
		if(start==konec+1){
			LinkedList<Stav> vysledek=new LinkedList<Stav>();
			vysledek.add(stav);
			return vysledek;
		}
		if(stav.promenneInt.containsKey(promenna))
			stav.promenneInt.put(promenna, start);
		else
			stav.lokalInt.put(promenna, start);
		LinkedList<Stav> vysledek=proved(program.get(proved), tahle, stav);
		LinkedList<Stav> vysledek2=new LinkedList<Stav>();
		for(int i=0;i<vysledek.size();++i){
			vysledek2.addAll(for1(promenna, start+1, konec, proved, tahle, stav));
		}
		return vysledek2;
	}
	
	/**
	 * Zmn, kter hr je na ad.
	 * @param kolik - o kolik se m aktuln hr posunout
	 * @param stav - stav, ve kterm se hra nachz
	 */
	void next(String kolik, Stav stav){
		if(kolik.startsWith("|")){
			stav.naRade=vypocty(kolik.substring(1, kolik.length()-1), stav);
		}
		else{
			int posun=vypocty(kolik, stav);
			int pomocny=stav.naRade+posun;
			if(pomocny>=0)
				stav.naRade=pomocny%pocetHracu;
			else{
				while(pomocny<0)
					pomocny+=pocetHracu;
				stav.naRade=pomocny%pocetHracu;
			}
		}
	}
	
	/**
	 * Z danho msta odstran button.
	 * @param umisteni - umstn buttonu
	 * @param tahle - aktuln karta
	 * @param stav - stav, ve kterm se hra nachz
	 */
	void button(String umisteni, String tahle, Stav stav){
		StringTokenizer st=new StringTokenizer(umisteno(umisteni, tahle, stav));
		int hrac=Integer.parseInt(st.nextToken());
		String misto=st.nextToken();
		stav.pozice.get(hrac).put(misto, new LinkedList<Integer>());
	}
	
	/**
	 * Na dan msto pid button s danm textem.
	 * @param umisteni - umstn buttonu
	 * @param text - text buttonu
	 * @param tahle - aktuln karta
	 * @param stav - stav, ve kterm se hra nachz
	 */
	void button(String umisteni, String text, String tahle, Stav stav){
		StringTokenizer st=new StringTokenizer(umisteno(umisteni, tahle, stav));
		int hrac=Integer.parseInt(st.nextToken());
		String misto=st.nextToken();
		stav.pozice.get(hrac).get(misto).add(-1);
	}
	
	/**
	 * Zamch karty.
	 * @param co - karty co se maj zamchat
	 * @param kam - kam se maj karty zamchat
	 * @param tahle - aktuln karta
	 * @param stav - stav, ve kterm se hra nachz
	 */
	void zamichat(String co, String kam, String tahle, Stav stav){
		StringTokenizer st=new StringTokenizer(umisteno(kam, tahle, stav));
		int hrac=Integer.parseInt(st.nextToken());
		String misto=st.nextToken();
		if(co.equals("all"))
			for(int i=0;i<stav.pozice.size();++i)
				for(String s:stav.pozice.get(i).keySet())
					move(i+"."+s, kam, tahle, stav);
		else
			move(co, kam, tahle, stav);
		if(co.equals("all")){
			stav.pozice.get(hrac).put(misto, new LinkedList<Integer>());
			for(int i=0;i<balicek.size();++i)
				stav.pozice.get(hrac).get(misto).add(i);
		}
		LinkedList<Integer> balik=new LinkedList<Integer>();
		balik.addAll(stav.pozice.get(hrac).get(misto));
		stav.pozice.get(hrac).put(misto, new LinkedList<Integer>());
		while(balik.size()!=0){
			stav.pozice.get(hrac).get(misto).add(balik.remove(new Random().nextInt(balik.size())));
		}
	}
	
	/**
	 * Zjiuje absolutn msto zadan relativn nebo hodnoty parametr karet.
	 * @param kde - msto
	 * @param tahle - aktuln karta
	 * @param stav - stav, ve kterm se hra nachz
	 * @return msto nebo hodnotu
	 */
	String umisteno(String kde, String tahle, Stav stav){
		StringTokenizer st=new StringTokenizer(kde, ".");
		String hrac=st.nextToken();
		if(hrac.equals("this"))
			return tahle;
		else if(hrac.equals("stred"))
			hrac=((Integer)pocetHracu).toString();
		else if(st.hasMoreTokens())
			hrac=((Integer)vypocty(hrac, stav)).toString();
		else{
			int karta=Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1));
			return balicek.get(karta).parametry.get(hrac);
		}
		String misto=st.nextToken();
		if(!st.hasMoreTokens())
			return hrac+" "+misto;
		String co=st.nextToken();
		if(co.equals("first"))
			co=stav.pozice.get(Integer.parseInt(hrac)).get(misto).getFirst().toString();
		else if(co.equals("last"))
			co=stav.pozice.get(Integer.parseInt(hrac)).get(misto).getLast().toString();
		else if(co.startsWith("get"))
			co=stav.pozice.get(Integer.parseInt(hrac)).get(misto).get(vypocty(co.substring(co.indexOf("(")+1, co.length()-1), stav)).toString();
		else if(co.startsWith("contains")){
			while(st.hasMoreTokens())
				co+="."+st.nextToken();
			for(int i=0;i<stav.pozice.get(Integer.parseInt(hrac)).get(misto).size();++i){
				int a=stav.pozice.get(Integer.parseInt(hrac)).get(misto).get(i);
				if(podminky(co.substring(9, co.length()-1), hrac+" "+misto+" "+a, stav))
					return "true";
			}
			return "false";
		}
		else if(co.startsWith("size"))
			return ((Integer)stav.pozice.get(Integer.parseInt(hrac)).get(misto).size()).toString();
		if(!st.hasMoreTokens())
			return hrac+" "+misto+" "+co;
		String parametr=st.nextToken();
		return balicek.get(Integer.parseInt(co)).parametry.get(parametr);
	}
	
	/**
	 * Vypote hodnotu vrazu zadanho parametrem.
	 * @param co - vraz k vypoten
	 * @param stav - stav, ve kterm se hra nachz
	 * @return hodnota vrazu
	 */
	int vypocty(String co, Stav stav){
		while(co.contains("(")){
			int parovani=0;
			for(int i=co.indexOf("(");i<co.length();++i){
				if(co.charAt(i)=='(')
					++parovani;
				else if(co.charAt(i)==')')
					--parovani;
				if(parovani==0){
					parovani=i;
					break;
				}
			}
			String pred;
			String za;
			if(co.indexOf("(")==0)
				pred="";
			else
				pred=co.substring(0, co.indexOf("("));
			if(parovani==co.length()-1)
				za="";
			else
				za=co.substring(parovani+1);
			co=pred+vypocty(co.substring(co.indexOf("(")+1, parovani), stav)+za;
		}
		if(co.contains("+")||co.contains("-"))
			if(co.indexOf("+")>co.indexOf("-"))
				return vypocty(co.substring(0, co.indexOf("+")), stav)+vypocty(co.substring(co.indexOf("+")+1), stav);
			else
				return vypocty(co.substring(0, co.indexOf("-")), stav)-vypocty(co.substring(co.indexOf("-")+1), stav);
		if(co.contains("*")||co.contains("/"))
			if(co.indexOf("*")>co.indexOf("/"))
				return vypocty(co.substring(0, co.indexOf("*")), stav)*vypocty(co.substring(co.indexOf("*")+1), stav);
			else
				return vypocty(co.substring(0, co.indexOf("/")), stav)/vypocty(co.substring(co.indexOf("/")+1), stav);
		if(co.contains("%"))
			return vypocty(co.substring(0, co.indexOf("%")), stav)%vypocty(co.substring(co.indexOf("%")+1), stav);
		if(stav.lokalInt.containsKey(co))
			return stav.lokalInt.get(co);
		else if(stav.promenneInt.containsKey(co))
			return stav.promenneInt.get(co);
		else if(co.equals("tah"))
			return stav.naRade;
		else if(co.equals("pocethracu"))
			return pocetHracu;
		else
			return Integer.parseInt(co);
	}
	
	/**
	 * Vyhodnot zadanou podmnku.
	 * @param co - podmnka ke zkontrolovn
	 * @param tahle - aktuln karta
	 * @param stav - stav, ve kterm se hra nachz
	 * @return true jestli podmnka plat, jinak false
	 */
	boolean podminky(String co, String tahle, Stav stav){
		StringTokenizer and=new StringTokenizer(co, "&&");
		boolean vnejsi=true;
		while(and.hasMoreTokens()){
			StringTokenizer or=new StringTokenizer(and.nextToken(), "||");
			boolean vnitrni=false;
			while(or.hasMoreTokens()){
				String cele=or.nextToken();
				boolean negace=false;
				if(cele.startsWith("not ")){
					negace=true;
					cele=cele.substring(4);
				}
				String a;
				String b;
				int operator;
				if(cele.contains("contains(")){
					int pocet=0;
					for(int i=9;i<cele.length();++i){
						if(cele.charAt(i)=='(')
							++pocet;
						else if(cele.charAt(i)==')')
							--pocet;
						if(pocet!=0&&i==cele.length()-1){
							if(!or.hasMoreTokens())
								or=new StringTokenizer(and.nextToken(), "||");
							cele.concat(or.nextToken());
						}
					}
					if(umisteno(cele, tahle, stav).equals("true")){
						if(negace)
							return false;
						else
							return true;
					}
					else if(negace)
						return true;
					else
						return false;
				}
				else if(cele.contains("=")){
					StringTokenizer operatory=new StringTokenizer(cele, "=");
					a=operatory.nextToken();
					b=operatory.nextToken();
					operator=0;
				}
				else if(cele.contains("<")){
					StringTokenizer operatory=new StringTokenizer(cele, "<");
					a=operatory.nextToken();
					b=operatory.nextToken();
					operator=1;
				}
				else{
					StringTokenizer operatory=new StringTokenizer(cele, ">");
					a=operatory.nextToken();
					b=operatory.nextToken();
					operator=2;
				}
				if(!tahle.equals("")&&balicek.get(Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1))).parametry.containsKey(a)||a.contains("."))
					a=umisteno(a, tahle, stav);
				else if(a.contains("\""))
					a=a.substring(1, a.length()-1);
				else if(stav.lokalString.containsKey(a))
					a=stav.lokalString.get(a);
				else if(stav.promenneString.containsKey(a))
					a=stav.promenneString.get(a);
				else if(stav.lokalInt.containsKey(a))
					a=stav.lokalInt.get(a).toString();
				else
					a=((Integer)vypocty(a, stav)).toString();
				if(!tahle.equals("")&&balicek.get(Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1))).parametry.containsKey(b)||b.contains("."))
					b=umisteno(b, tahle, stav);
				else if(b.contains("\""))
					b=b.substring(1, b.length()-1);
				else if(stav.lokalString.containsKey(b))
					b=stav.lokalString.get(b);
				else if(stav.promenneString.containsKey(b))
					b=stav.promenneString.get(b);
				else
					b=((Integer)vypocty(b, stav)).toString();
				if(operator==0){
					if(a.equals(b))
						vnitrni=true;
				}
				else if(operator==1){
					if(porovnani.contains(a)){
						if(porovnani.indexOf(a)<porovnani.indexOf(b))
							vnitrni=true;
					}
					else{
						if(Integer.parseInt(a)<Integer.parseInt(b))
							vnitrni=true;
					}
				}
				else{
					if(porovnani.contains(a)){
						if(porovnani.indexOf(a)>porovnani.indexOf(b))
							vnitrni=true;
					}
					else{
						if(Integer.parseInt(a)>Integer.parseInt(b))
							vnitrni=true;
					}
				}
				if(negace)
					if(vnitrni)
						vnitrni=false;
					else
						vnitrni=true;
				if(vnitrni)
					break;
			}
			if(!vnitrni){
				vnejsi=false;
				break;
			}
		}
		if(vnejsi)
			return true;
		else
			return false;
	}
	
	/**
	 * Piad hodnotu do promnn.
	 * @param co - hodnota k piazen
	 * @param kam - promnn, do kter se piazuje
	 * @param tahle - aktuln karta
	 * @param stav - stav, ve kterm se hra nachz
	 */
	void priradit(String co, String kam, String tahle, Stav stav){
		String s;
		if(co.contains("\""))
			s=co.substring(1, co.length()-1);
		else if(!tahle.equals("")&&balicek.get(Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1))).parametry.containsKey(co)||co.contains("."))
			s=umisteno(co, tahle, stav);
		else if(stav.lokalString.containsKey(co))
			s=stav.lokalString.get(co);
		else if(stav.promenneString.containsKey(co))
			s=stav.promenneString.get(co);
		else
			s=((Integer)vypocty(co, stav)).toString();
		if(stav.lokalString.containsKey(kam))
			stav.lokalString.put(kam, s);
		else if(stav.lokalInt.containsKey(kam))
			stav.lokalInt.put(kam, Integer.parseInt(s));
		else if(stav.promenneString.containsKey(kam))
			stav.promenneString.put(kam, s);
		else if(stav.promenneInt.containsKey(kam))
			stav.promenneInt.put(kam, Integer.parseInt(s));
		else
			stav.lokalInt.put(((Integer)vypocty(kam, stav)).toString(), Integer.parseInt(s));
	}
}

