package sit;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;

import javax.swing.*;

import data.Informace;
import GUI.Main;

/**
 * Slou k obsluze klienta.
 * @author Ondej Papk
 *
 */
public class Klient extends Thread{
	/**
	 * Vstupn reader.
	 */
	BufferedReader in;
	/**
	 * Vstupn writer.
	 */
	PrintWriter out;
	/**
	 * JFrame hlavnho programu.
	 */
	JFrame frame;
	/**
	 * Informace o he.
	 */
	Informace inf;
	/**
	 * Panely s kartami ped hri.
	 */
	Hrac[] seznamHracu;
	/**
	 * Poet hr.
	 */
	int hracu;
	/**
	 * Kolikt je tento hr.
	 */
	int kolikaty;
	/**
	 * Dialog se hrou.
	 */
	JDialog dialog;
	/**
	 * Seznam se vemi kartami.
	 */
	LinkedList<JLabel> karty=new LinkedList<JLabel>();
	/**
	 * Seznam se zadnimi stranami karet.
	 */
	LinkedList<JLabel> pozadi=new LinkedList<JLabel>();
	
	/**
	 * Konstruktor
	 * @param f JFrame hlavnho programu.
	 * @param i informace o he.
	 */
	public Klient(JFrame f, Informace i){
		frame=f;
		inf=i;
		this.start();
	}
	
	/**
	 * Metoda run tdy Thread.
	 */
	public void run(){
		Socket socket=null;
		try {
			InetAddress addr;
			if(!Main.hrat.ip.getText().equals("")){
				byte[] b=new byte[4];
				StringTokenizer st=new StringTokenizer(Main.hrat.ip.getText());
				for(int i=0;i<4;++i){
					b[i]=(byte)Integer.parseInt(st.nextToken("."));
				}
				addr=InetAddress.getByAddress(b);
			}
			else
				addr=InetAddress.getByName(null);
			socket=new Socket(addr, 6666);
			in=new BufferedReader(new InputStreamReader(socket.getInputStream()));
			out=new PrintWriter(new OutputStreamWriter(socket.getOutputStream()), true);
			hracu=Integer.parseInt(in.readLine());
			kolikaty=Integer.parseInt(in.readLine());
			createAndShowDialog();
			pripravit();
			while(true){
				String s=in.readLine();
				if(s.equals("end"))
					break;
				else{
					proved(s);
				}
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
		} catch (NullPointerException e) {
			// TODO Auto-generated catch block
		} finally {
			try {
				in.close();
				out.close();
				socket.close();
				dialog.setVisible(false);
			} catch (IOException e) {
				// TODO Auto-generated catch block
			}
		}
	}
	
	/**
	 * Vytvo a zobraz hru.
	 * @param hracu poet hr.
	 * @param kolikaty uruje kolikt je klient hr (indexovno od 0).
	 */
	void createAndShowDialog(){
		dialog=new JDialog(frame, inf.getNazev()+", Hr: "+kolikaty+", hraje: 0");
		dialog.addComponentListener(new ComponentListener() {
			
			@Override
			public void componentShown(ComponentEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void componentResized(ComponentEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void componentMoved(ComponentEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void componentHidden(ComponentEvent e) {
				// TODO Auto-generated method stub
				out.println("end");
			}
		});
		Hrac hrac=new Hrac();
		for(int i=0;i<inf.getVzhled().getNazevHrac().size();++i){
			hrac.vloz(inf.getVzhled().getNazevHrac().get(i).getText(), Integer.parseInt(inf.getVzhled().getUmisteniHrac().get(2*i).getText()), Integer.parseInt(inf.getVzhled().getUmisteniHrac().get(2*i+1).getText()));			
		}
		seznamHracu=new Hrac[hracu+1];
		for(int i=0;i<hracu;++i){
			Hrac a=new Hrac();
			a.copy(hrac);
			seznamHracu[i]=a;
		}
		hrac=new Hrac();
		for(int i=0;i<inf.getVzhled().getNazevStred().size();++i){
			hrac.vloz(inf.getVzhled().getNazevStred().get(i).getText(), Integer.parseInt(inf.getVzhled().getUmisteniStred().get(2*i).getText()), Integer.parseInt(inf.getVzhled().getUmisteniStred().get(2*i+1).getText()));
		}
		seznamHracu[seznamHracu.length-1]=hrac;
		dialog.setLayout(new BorderLayout());
		dialog.add(hrac, BorderLayout.CENTER);
		dialog.add(seznamHracu[kolikaty], BorderLayout.SOUTH);
		if(hracu==2)
			dialog.add(seznamHracu[(kolikaty+1)%hracu], BorderLayout.NORTH);
		if(hracu==3){
			dialog.add(seznamHracu[(kolikaty+1)%hracu], BorderLayout.WEST);
			dialog.add(seznamHracu[(kolikaty+2)%hracu], BorderLayout.EAST);
		}
		if(hracu==4){
			dialog.add(seznamHracu[(kolikaty+1)%hracu], BorderLayout.WEST);
			dialog.add(seznamHracu[(kolikaty+2)%hracu], BorderLayout.NORTH);
			dialog.add(seznamHracu[(kolikaty+3)%hracu], BorderLayout.EAST);
		}
		dialog.pack();
		dialog.setSize(700, 700);
		dialog.getContentPane().setBackground(Color.GREEN);
		dialog.setVisible(true);
	}
	
	/**
	 * Piprav obrzky karet.
	 */
	void pripravit(){
		for(int i=0;i<inf.getKarty().getZvolena().getItemCount();++i){
			for(int j=0;j<Integer.parseInt(inf.getKarty().getPocty().get(inf.getKarty().getZvolena().getItemAt(i))[0].getText());++j){
				JLabel l=new JLabel();
				l.setIcon(inf.getKarty().getObrazky().get(inf.getKarty().getZvolena().getItemAt(i)).getIcon());
				karty.add(l);
			}
		}
		for(int i=0;i<karty.size();++i){
			JLabel l=new JLabel();
			l.setIcon(inf.getKarty().getObrazky().get("pozadi").getIcon());
			pozadi.add(l);
		}
	}
	
	/**
	 * Provede zadanou pravu.
	 * @param prikaz - prava co se m provst
	 */
	void proved(String prikaz){
		StringTokenizer radek=new StringTokenizer(prikaz);
		String aktivita=radek.nextToken();
		if(aktivita.equals("ins")){
			final int hrac=Integer.parseInt(radek.nextToken());
			final String misto=radek.nextToken();
			String co=radek.nextToken();
			if(co.equals("lab")){
				seznamHracu[hrac].panely.get(misto).add(new JLabel(radek.nextToken()));
				seznamHracu[hrac].panely.get(misto).updateUI();
			}
			else if(co.equals("but")){
				JButton button=new JButton(radek.nextToken());
				seznamHracu[hrac].panely.get(misto).add(button);
				button.addActionListener(new ActionListener() {
					
					@Override
					public void actionPerformed(ActionEvent arg0) {
						// TODO Auto-generated method stub
						out.println("button "+hrac+" "+misto);
					}
				});
				button.updateUI();
			}
			else{
				final int karta=Integer.parseInt(co);
				LinkedList<JLabel> odkud;
				if(radek.nextToken().equals("true"))
					odkud=karty;
				else
					odkud=pozadi;
				seznamHracu[hrac].panely.get(misto).add(odkud.get(karta));
				odkud.get(karta).updateUI();
				odkud.get(karta).addMouseListener(new MouseListener() {
					
					@Override
					public void mouseReleased(MouseEvent arg0) {
						// TODO Auto-generated method stub
						
					}
					
					@Override
					public void mousePressed(MouseEvent arg0) {
						// TODO Auto-generated method stub
						
					}
					
					@Override
					public void mouseExited(MouseEvent arg0) {
						// TODO Auto-generated method stub
						
					}
					
					@Override
					public void mouseEntered(MouseEvent arg0) {
						// TODO Auto-generated method stub
						
					}
					
					@Override
					public void mouseClicked(MouseEvent arg0) {
						// TODO Auto-generated method stub
						out.println("klik "+hrac+" "+misto+" "+karta);
					}
				});
			}
		}
		else if(aktivita.equals("del")){
			int hrac=Integer.parseInt(radek.nextToken());
			String misto=radek.nextToken();
			String co=radek.nextToken();
			if(co.equals("lab")||co.equals("but")){
				seznamHracu[hrac].panely.get(misto).removeAll();
				seznamHracu[hrac].panely.get(misto).updateUI();
			}
			else{
				int karta=Integer.parseInt(co);
				LinkedList<JLabel> odkud;
				if(radek.nextToken().equals("true"))
					odkud=karty;
				else
					odkud=pozadi;
				seznamHracu[hrac].panely.get(misto).remove(odkud.get(karta));
				JLabel l=new JLabel();
				l.setIcon(odkud.get(karta).getIcon());
				odkud.set(karta, l);
			}
		}
		else if(aktivita.equals("show")){
			final JDialog d=new JDialog(dialog, "vyber");
			d.setLocationRelativeTo(dialog);
			d.setLayout(new GridLayout(0, 1));
			while(radek.hasMoreTokens()){
				final String text=radek.nextToken();
				JButton button=new JButton(text);
				d.add(button);
				button.addActionListener(new ActionListener() {
					
					@Override
					public void actionPerformed(ActionEvent arg0) {
						// TODO Auto-generated method stub
						out.println(text);
						d.setVisible(false);
					}
				});
			}
			d.pack();
			d.setVisible(true);
		}
		else if(aktivita.equals("showinf")){
			JOptionPane.showMessageDialog(dialog, radek.nextToken(), "info", JOptionPane.INFORMATION_MESSAGE);
		}
		else if(aktivita.equals("next")){
			dialog.setTitle(inf.getNazev()+", Hr: "+kolikaty+", hraje: "+radek.nextToken());
		}
	}
}
