package sit;


import inteligence.Automat;
import inteligence.UINapsana;
import inteligence.UIUniverzalni;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.net.*;
import java.util.*;

import javax.swing.*;

import data.Informace;
import GUI.*;

/**
 * Slou k obsluze serveru. Kad instance tto tdy komunikuje s jednm hrem.
 * @author Ondej Papk
 *
 */
public class Server extends Thread{
	/**
	 * Vstupn reader.
	 */
	BufferedReader in;
	/**
	 * Vstupn writer.
	 */
	PrintWriter out;
	/**
	 * Seznam jednotlivch vlken.
	 */
	static LinkedList<Server> odeslani=new LinkedList<Server>();
	/**
	 * Poad hre, ktermu pat toto vlkno.
	 */
	int poradi;
	/**
	 * Socket.
	 */
	Socket socket;
	/**
	 * ServerSocket.
	 */
	static ServerSocket s;
	/**
	 * Hr, kter je na tahu.
	 */
	static int tah=0;
	/**
	 * Poet hr.
	 */
	static int pocetHracu;
	/**
	 * Seznam karet. Seznam seznamu parametr, kde kl je nzev a vsledek je hodnota parametru.
	 */
	public static LinkedList<HashMap<String, String>> karty=new LinkedList<HashMap<String, String>>();
	/**
	 * Seznam karet hr. Jedn se o seznam hr, potom se zad msto u hre a vsledek je seznam karet.
	 */
	public static LinkedList<HashMap<String, LinkedList<HashMap<String, String>>>> umisteniKaret=new LinkedList<HashMap<String, LinkedList<HashMap<String, String>>>>();
	/**
	 * Informace o umstn label a button.
	 */
	static LinkedList<HashMap<String, String>> labBut=new LinkedList<HashMap<String, String>>();
	/**
	 * Stringov promnn.
	 */
	public static HashMap<String, String> promenneString=new HashMap<String, String>();
	/**
	 * Intov promnn.
	 */
	public static HashMap<String, Integer> promenneInt=new HashMap<String, Integer>();
	/**
	 * Hlaviky pravidel.
	 */
	static HashMap<String[], Integer> hlavicky=new HashMap<String[], Integer>();
	/**
	 * Program k vykonn.
	 */
	static LinkedList<LinkedList<LinkedList<String>>> program=new LinkedList<LinkedList<LinkedList<String>>>();
	/**
	 * Informace o viditelnosti komponent.
	 */
	static LinkedList<HashMap<String, boolean[]>> viditelnost=new LinkedList<HashMap<String, boolean[]>>();
	/**
	 * Slou k porovnvn string.
	 */
	public static LinkedList<String> porovnani=new LinkedList<String>();
	
	/**
	 * Konstruktor
	 * @param inf informace o he
	 * @param frame JFrame hlavnho programu
	 */
	public Server(final Informace inf, JFrame frame){
		try {
			s=new ServerSocket(6666);
			pocetHracu=(int)Main.hrat.hracu.getSelectedItem();
			Automat automat=new Automat(true, inf);
			if(Main.hrat.inteligence.isSelected()&&!automat.vypocet(inf.getUI().getText().getText()).equals("")){
				JOptionPane.showMessageDialog(frame, "Ve vlastn uml inteligenci byla nalezana chyba.", "chyba", JOptionPane.ERROR_MESSAGE);
				s.close();
				return;
			}
			automat=new Automat(false, inf);
			if(!automat.vypocet(inf.getPravidla().getText().getText()).equals("")){
				JOptionPane.showMessageDialog(frame, "V pravidlech byla nalezana chyba.", "chyba", JOptionPane.ERROR_MESSAGE);
				s.close();
				return;
			}
			pripravit(inf, automat);
			tah=0;
			Main.hrat.ip.setText("");
			new Klient(frame, inf);
			final int pocitac=(int) Main.hrat.pocitacem.getSelectedItem();
			final JDialog dialog=new JDialog(frame, "ekn", true);
			dialog.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
			dialog.setLayout(new GridLayout(0, 1));
			dialog.add(new JLabel("ekm na ostatn hre..."));
			JButton button=new JButton("Ukonit");
			dialog.add(button);
			dialog.pack();
			dialog.setLocationRelativeTo(frame);
			final SwingWorker<Object, Object> worker=new SwingWorker<Object, Object>(){
				protected Object doInBackground(){
					try{
						int pocitacem=pocitac;
						for(int i=0;i<pocetHracu;++i){
							if(i!=0&&new Random().nextInt(pocetHracu-i)<pocitacem){
								--pocitacem;
								if(Main.hrat.inteligence.isSelected())
									new UINapsana(inf);
								else
									new UIUniverzalni(inf, pocetHracu, hlavicky, program, porovnani);
							}
							Socket socket=s.accept();
							odeslani.add(new Server(socket, i));
							odeslani.get(i).out.println(pocetHracu);
							odeslani.get(i).out.println(i);
						}
						for(int i=0;i<pocetHracu;++i)
							odeslani.get(i).start();
						for(String [] i:hlavicky.keySet())
							if(i[0].equals("start")){
								HashMap<String, String> lokalString=new HashMap<String, String>();
								HashMap<String, Integer> lokalInt=new HashMap<String, Integer>();
								StringTokenizer st=new StringTokenizer(i[1]);
								while(st.hasMoreTokens())
									lokalString.put(st.nextToken(), "");
								st=new StringTokenizer(i[2]);
								while(st.hasMoreTokens())
									lokalInt.put(st.nextToken(), 0);
								proved(program.get(hlavicky.get(i)), "", lokalString, lokalInt);
								break;
							}
					} catch(IOException e){
						for(Server i:odeslani)
							try {
								i.in.close();
								i.out.close();
								i.socket.close();
							} catch (IOException e1) {
							}
						try {
							odeslani=new LinkedList<Server>();
							s.close();
						} catch (IOException e1) {
						}
					}
					return null;
				}
				protected void done(){
					dialog.setVisible(false);
				}
			};
			worker.execute();
			button.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					worker.cancel(false);
					for(Server i:odeslani)
						try {
							i.in.close();
							i.out.close();
							i.socket.close();
						} catch (IOException e1) {
						}
					try {
						odeslani=new LinkedList<Server>();
						s.close();
					} catch (IOException e1) {
					}
				}
			});
			dialog.setVisible(true);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			for(Server i:odeslani)
				try {
					i.in.close();
					i.out.close();
					i.socket.close();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
				}
			try {
				odeslani=new LinkedList<Server>();
				s.close();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
			}
		}
	}
	
	/**
	 * Konstruktor
	 * @param socket socket k pipojen.
	 * @param kolikaty uruje poad hre, ktermu pat toto vlkno serveru.
	 */
	public Server(Socket socket, int kolikaty){
		try {
			in=new BufferedReader(new InputStreamReader(socket.getInputStream()));
			out=new PrintWriter(new OutputStreamWriter(socket.getOutputStream()),true);
			poradi=kolikaty;
			this.socket=socket;
		} catch (IOException e) {
			// TODO Auto-generated catch block
			for(Server i:odeslani)
				try {
					i.in.close();
					i.out.close();
					i.socket.close();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
				}
			try {
				odeslani=new LinkedList<Server>();
				s.close();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
			}
		}
	}
	
	/**
	 * Piprav hru podle zadanch informac.
	 * @param inf - informace o he
	 */
	void pripravit(Informace inf, Automat automat){
		karty=new LinkedList<HashMap<String,String>>();
		umisteniKaret=new LinkedList<HashMap<String,LinkedList<HashMap<String,String>>>>();
		labBut=new LinkedList<HashMap<String,String>>();
		for(int i=0;i<inf.getKarty().getZvolena().getItemCount();++i)
			for(int j=0;j<Integer.parseInt(inf.getKarty().getPocty().get(inf.getKarty().getZvolena().getItemAt(i))[0].getText());++j){
				HashMap<String, String> karta=new HashMap<String, String>();
				for(String parametr:inf.getKarty().getSeznamParametru())
					karta.put(parametr, inf.getKarty().getParametry().get(inf.getKarty().getZvolena().getItemAt(i)).get(parametr).getText());
				karty.add(karta);
			}
		for(int i=0;i<pocetHracu;++i){
			umisteniKaret.add(new HashMap<String, LinkedList<HashMap<String,String>>>());
			labBut.add(new HashMap<String, String>());
			viditelnost.add(new HashMap<String, boolean[]>());
			for(int j=0;j<inf.getVzhled().getNazevHrac().size();++j){
				umisteniKaret.get(i).put(inf.getVzhled().getNazevHrac().get(j).getText(), new LinkedList<HashMap<String, String>>());
				labBut.get(i).put(inf.getVzhled().getNazevHrac().get(j).getText(), "");
				viditelnost.get(i).put(inf.getVzhled().getNazevHrac().get(j).getText(), new boolean[3]);
				viditelnost.get(i).get(inf.getVzhled().getNazevHrac().get(j).getText())[0]=inf.getVzhled().getVerejneHrac().get(j*5+3).isSelected();
				viditelnost.get(i).get(inf.getVzhled().getNazevHrac().get(j).getText())[1]=inf.getVzhled().getVerejneHrac().get(j*5).isSelected();
				viditelnost.get(i).get(inf.getVzhled().getNazevHrac().get(j).getText())[2]=inf.getVzhled().getVerejneHrac().get(j*5+1).isSelected();
			}
		}
		while(viditelnost.size()>1)
			viditelnost.removeLast();
		umisteniKaret.add(new HashMap<String, LinkedList<HashMap<String,String>>>());
		labBut.add(new HashMap<String, String>());
		viditelnost.add(new HashMap<String, boolean[]>());
		for(int j=0;j<inf.getVzhled().getNazevStred().size();++j){
			umisteniKaret.get(pocetHracu).put(inf.getVzhled().getNazevStred().get(j).getText(), new LinkedList<HashMap<String, String>>());
			labBut.get(pocetHracu).put(inf.getVzhled().getNazevStred().get(j).getText(), "");
			viditelnost.get(1).put(inf.getVzhled().getNazevStred().get(j).getText(), new boolean[2]);
			viditelnost.get(1).get(inf.getVzhled().getNazevStred().get(j).getText())[0]=inf.getVzhled().getVerejneStred().get(j*4+2).isSelected();
			viditelnost.get(1).get(inf.getVzhled().getNazevStred().get(j).getText())[1]=inf.getVzhled().getVerejneStred().get(j*4).isSelected();
		}
		program=automat.program;
		hlavicky=automat.hlavicky;
		promenneInt=automat.promenneInt;
		promenneString=automat.promenneString;
		porovnani=automat.porovnatelne;
	}
	
	/**
	 * Provede zadan pkazy.
	 * @param radky - seznam pkaz s parametry
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 */
	void proved(LinkedList<LinkedList<String>> radky, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		for(int i=0;i<radky.size();++i){
			String prikaz=radky.get(i).get(0);
			if(prikaz.equals("move")){
				move(radky.get(i).get(1), radky.get(i).get(2), tahle, lokalString, lokalInt);
			}
			else if(prikaz.equals("if")){
				if1(radky.get(i).get(1), Integer.parseInt(radky.get(i).get(2)), Integer.parseInt(radky.get(i).get(3)), tahle, lokalString, lokalInt);
			}
			else if(prikaz.equals("for")){
				for1(radky.get(i).get(1), radky.get(i).get(2), radky.get(i).get(3), Integer.parseInt(radky.get(i).get(4)), tahle, lokalString, lokalInt);
			}
			else if(prikaz.equals("next")){
				next(radky.get(i).get(1), lokalInt);
			}
			else if(prikaz.equals("showinf")){
				showinf(radky.get(i).get(1), tahle, lokalString, lokalInt);
			}
			else if(prikaz.equals("label")){
				if(radky.get(i).size()==2)
					label(radky.get(i).get(1), tahle, lokalString, lokalInt);
				else
					label(radky.get(i).get(1), radky.get(i).get(2), tahle, lokalString, lokalInt);
			}
			else if(prikaz.equals("button")){
				if(radky.get(i).size()==2)
					button(radky.get(i).get(1), tahle, lokalString, lokalInt);
				else
					button(radky.get(i).get(1), radky.get(i).get(2), tahle, lokalString, lokalInt);
			}
			else if(prikaz.equals("shuffle")){
				zamichat(radky.get(i).get(1), radky.get(i).get(2), tahle, lokalString, lokalInt);
			}
			else if(prikaz.equals("=")){
				priradit(radky.get(i).get(2), radky.get(i).get(1), tahle, lokalString, lokalInt);
			}
		}
	}
	
	/**
	 * Pesune karty.
	 * @param co - karta/y k pesunu
	 * @param kam - umstn karet
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 */
	void move(String co, String kam, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		StringTokenizer st=new StringTokenizer(umisteno(kam, tahle, lokalString, lokalInt));
		int kamHrac=Integer.parseInt(st.nextToken());
		String kamMisto=st.nextToken();
		if(labBut.get(kamHrac).get(kamMisto).equals("label")||labBut.get(kamHrac).get(kamMisto).equals("button"))
			return;
		st=new StringTokenizer(umisteno(co, tahle, lokalString, lokalInt));
		int odHrac=Integer.parseInt(st.nextToken());
		String odMisto=st.nextToken();
		LinkedList<Integer> odCo=new LinkedList<Integer>();
		int a;
		if(odHrac==pocetHracu)
			a=1;
		else
			a=0;
		if(st.hasMoreTokens())
			odCo.add(Integer.parseInt(st.nextToken()));
		else
			for(int i=0;i<umisteniKaret.get(odHrac).get(odMisto).size();++i)
				odCo.add(karty.indexOf(umisteniKaret.get(odHrac).get(odMisto).get(i)));
		for(int i=odCo.size()-1;i>-1;--i){
			umisteniKaret.get(odHrac).get(odMisto).remove(karty.get(odCo.get(i)));
			umisteniKaret.get(kamHrac).get(kamMisto).add(karty.get(odCo.get(i)));
		}
		if(viditelnost.get(a).get(odMisto)[0]){
			for(int i=0;i<odCo.size();++i)
				for(int j=0;j<odeslani.size();++j)
					if(viditelnost.get(a).get(odMisto)[2-a]||a==0&&viditelnost.get(a).get(odMisto)[1]&&j==odHrac)
						odeslani.get(j).out.println("del "+odHrac+" "+odMisto+" "+odCo.get(i)+" true");
					else
						odeslani.get(j).out.println("del "+odHrac+" "+odMisto+" "+odCo.get(i)+" false");
		}
		else if(odCo.size()>0){
			for(int j=0;j<odeslani.size();++j)
				if(viditelnost.get(a).get(odMisto)[2-a]||a==0&&viditelnost.get(a).get(odMisto)[1]&&j==odHrac){
					odeslani.get(j).out.println("del "+odHrac+" "+odMisto+" "+odCo.getLast()+" true");
					if(umisteniKaret.get(odHrac).get(odMisto).size()>0)
						odeslani.get(j).out.println("ins "+odHrac+" "+odMisto+" "+karty.indexOf(umisteniKaret.get(odHrac).get(odMisto).getLast())+" true");
				}
				else{
					odeslani.get(j).out.println("del "+odHrac+" "+odMisto+" "+odCo.getLast()+" false");
					if(umisteniKaret.get(odHrac).get(odMisto).size()>0)
						odeslani.get(j).out.println("ins "+odHrac+" "+odMisto+" "+karty.indexOf(umisteniKaret.get(odHrac).get(odMisto).getLast())+" false");
				}
		}
		if(kamHrac==pocetHracu)
			a=1;
		else
			a=0;
		if(viditelnost.get(a).get(kamMisto)[0]){
			for(int i=odCo.size()-1;i>-1;--i)
				for(int j=0;j<odeslani.size();++j)
					if(viditelnost.get(a).get(kamMisto)[2-a]||a==0&&viditelnost.get(a).get(kamMisto)[1]&&j==kamHrac)
						odeslani.get(j).out.println("ins "+kamHrac+" "+kamMisto+" "+odCo.get(i)+" true");
					else
						odeslani.get(j).out.println("ins "+kamHrac+" "+kamMisto+" "+odCo.get(i)+" false");
		}
		else if(odCo.size()>0){
			for(int j=0;j<odeslani.size();++j)
				if(viditelnost.get(a).get(kamMisto)[2-a]||a==0&&viditelnost.get(a).get(kamMisto)[1]&&j==kamHrac){
					if(umisteniKaret.get(kamHrac).get(kamMisto).size()>odCo.size())
						odeslani.get(j).out.println("del "+kamHrac+" "+kamMisto+" "+karty.indexOf(umisteniKaret.get(kamHrac).get(kamMisto).get(umisteniKaret.get(kamHrac).get(kamMisto).size()-1-odCo.size()))+" true");
					odeslani.get(j).out.println("ins "+kamHrac+" "+kamMisto+" "+odCo.getFirst()+" true");
				}
				else{
					if(umisteniKaret.get(kamHrac).get(kamMisto).size()>odCo.size())
						odeslani.get(j).out.println("del "+kamHrac+" "+kamMisto+" "+karty.indexOf(umisteniKaret.get(kamHrac).get(kamMisto).get(umisteniKaret.get(kamHrac).get(kamMisto).size()-1-odCo.size()))+" false");
					odeslani.get(j).out.println("ins "+kamHrac+" "+kamMisto+" "+odCo.getFirst()+" false");
				}
		}
	}
	
	/**
	 * Provede if.
	 * @param podminka - podmnka ifu.
	 * @param splneno - index s pkazy k proveden pi splnn podmnky
	 * @param nesplneno - index s pkazy k proveden pi nesplnn podmnky
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 */
	void if1(String podminka, int splneno, int nesplneno, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		if(podminky(podminka, tahle, lokalString, lokalInt))
			proved(program.get(splneno), tahle, lokalString, lokalInt);
		else if(nesplneno!=-1)
			proved(program.get(nesplneno), tahle, lokalString, lokalInt);
	}
	
	/**
	 * Provede for cyklus
	 * @param promenna - promenn vyuvan ve for cyklu
	 * @param start - poten hodnota
	 * @param konec - koncov hodnota
	 * @param proved - index s pkazy k proveden
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 */
	void for1(String promenna, String start, String konec, int proved, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		int a=vypocty(start, lokalInt);
		int b=vypocty(konec, lokalInt);
		for(int i=a;i<b+1;++i)
			if(promenneInt.containsKey(promenna)){
				promenneInt.put(promenna, i);
				proved(program.get(proved), tahle, lokalString, lokalInt);
			}
			else{
				lokalInt.put(promenna, i);
				proved(program.get(proved), tahle, lokalString, lokalInt);
			}
	}
	
	/**
	 * Zmn, kter hr je na ad.
	 * @param kolik - o kolik se m aktuln hr posunout
	 * @param lokalInt - lokln intov promnn
	 */
	void next(String kolik, HashMap<String, Integer> lokalInt){
		if(kolik.startsWith("|")){
			tah=vypocty(kolik.substring(1, kolik.length()-1), lokalInt);
		}
		else{
			int posun=vypocty(kolik, lokalInt);
			int pomocny=tah+posun;
			if(pomocny>=0)
				tah=pomocny%pocetHracu;
			else{
				while(pomocny<0)
					pomocny+=pocetHracu;
				tah=pomocny%pocetHracu;
			}
		}
	}
	
	/**
	 * Vrac vybranou hodnotu ze zadanch.
	 * @param vyber - hodnoty k vbru odlen mezerami
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 * @return vybran hodnota
	 */
	String show(String vyber, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		String upraveno="";
		StringTokenizer st=new StringTokenizer(vyber);
		while(st.hasMoreTokens()){
			String co=st.nextToken();
			if(co.contains("\""))
				upraveno+=" "+co.substring(1, co.length()-1);
			else if(co.contains(".")||(!tahle.equals("")&&karty.get(Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1))).containsKey(co)))
				upraveno+=" "+umisteno(co, tahle, lokalString, lokalInt);
			else if(lokalString.containsKey(co))
				upraveno+=" "+lokalString.get(co);
			else if(promenneString.containsKey(co))
				upraveno+=" "+promenneString.get(co);
			else
				upraveno+=" "+((Integer)vypocty(co, lokalInt)).toString();
			
		}
		out.println("show"+upraveno);
		String vybrano=null;
		try {
			vybrano=in.readLine();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return vybrano;
	}
	
	/**
	 * Uke zadanou informaci.
	 * @param co - text k zobrazen
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 */
	void showinf(String co, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		String s;
		if(co.contains("\""))
			s=co.substring(1, co.length()-1);
		else if(co.contains(".")||!tahle.equals("")&&karty.get(Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1))).containsKey(co))
			s=umisteno(co, tahle, lokalString, lokalInt);
		else if(lokalString.containsKey(co))
			s=lokalString.get(co);
		else if(promenneString.containsKey(co))
			s=promenneString.get(co);
		else
			s=((Integer)vypocty(co, lokalInt)).toString();
		for(int i=0;i<odeslani.size();++i)
			odeslani.get(i).out.println("showinf "+s);
	}
	
	/**
	 * Z danho msta odstran label.
	 * @param umisteni - umstn labelu
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 */
	void label(String umisteni, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		StringTokenizer st=new StringTokenizer(umisteno(umisteni, tahle, lokalString, lokalInt));
		int hrac=Integer.parseInt(st.nextToken());
		String misto=st.nextToken();
		labBut.get(hrac).put(misto, "");
		int a;
		if(hrac==pocetHracu)
			a=1;
		else
			a=0;
		for(int i=0;i<odeslani.size();++i)
			if(viditelnost.get(a).get(misto)[2-a]||a==0&&viditelnost.get(a).get(misto)[1]&&hrac==i)
				odeslani.get(i).out.println("del "+hrac+" "+misto+" "+"lab");
	}
	
	/**
	 * Na dan msto pid label s danm textem.
	 * @param umisteni - umstn labelu
	 * @param text - text labelu
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 */
	void label(String umisteni, String text, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		StringTokenizer st=new StringTokenizer(umisteno(umisteni, tahle, lokalString, lokalInt));
		int hrac=Integer.parseInt(st.nextToken());
		String misto=st.nextToken();
		labBut.get(hrac).put(misto, "label");
		int a;
		if(hrac==pocetHracu)
			a=1;
		else
			a=0;
		String s;
		if(text.contains("\""))
			s=text.substring(1, text.length()-1);
		else if(text.contains(".")||!tahle.equals("")&&karty.get(Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1))).containsKey(text))
			s=umisteno(text, tahle, lokalString, lokalInt);
		else if(lokalString.containsKey(text))
			s=lokalString.get(text);
		else if(promenneString.containsKey(text))
			s=promenneString.get(text);
		else
			s=((Integer)vypocty(text, lokalInt)).toString();
		for(int i=0;i<odeslani.size();++i)
			if(viditelnost.get(a).get(misto)[2-a]||a==0&&viditelnost.get(a).get(misto)[1]&&hrac==i)
				odeslani.get(i).out.println("ins "+hrac+" "+misto+" "+"lab "+s);
	}
	
	/**
	 * Z danho msta odstran button.
	 * @param umisteni - umstn buttonu
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 */
	void button(String umisteni, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		StringTokenizer st=new StringTokenizer(umisteno(umisteni, tahle, lokalString, lokalInt));
		int hrac=Integer.parseInt(st.nextToken());
		String misto=st.nextToken();
		labBut.get(hrac).put(misto, "");
		int a;
		if(hrac==pocetHracu)
			a=1;
		else
			a=0;
		for(int i=0;i<odeslani.size();++i)
			if(viditelnost.get(a).get(misto)[2-a]||a==0&&viditelnost.get(a).get(misto)[1]&&hrac==i)
				odeslani.get(i).out.println("del "+hrac+" "+misto+" "+"but");
	}
	
	/**
	 * Na dan msto pid button s danm textem.
	 * @param umisteni - umstn buttonu
	 * @param text - text buttonu
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 */
	void button(String umisteni, String text, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		StringTokenizer st=new StringTokenizer(umisteno(umisteni, tahle, lokalString, lokalInt));
		int hrac=Integer.parseInt(st.nextToken());
		String misto=st.nextToken();
		labBut.get(hrac).put(misto, "button");
		int a;
		if(hrac==pocetHracu)
			a=1;
		else
			a=0;
		String s;
		if(text.contains("\""))
			s=text.substring(1, text.length()-1);
		else if(text.contains(".")||!tahle.equals("")&&karty.get(Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1))).containsKey(text))
			s=umisteno(text, tahle, lokalString, lokalInt);
		else if(lokalString.containsKey(text))
			s=lokalString.get(text);
		else if(promenneString.containsKey(text))
			s=promenneString.get(text);
		else
			s=((Integer)vypocty(text, lokalInt)).toString();
		for(int i=0;i<odeslani.size();++i)
			if(viditelnost.get(a).get(misto)[2-a]||a==0&&viditelnost.get(a).get(misto)[1]&&hrac==i)
				odeslani.get(i).out.println("ins "+hrac+" "+misto+" "+"but "+s);
	}
	
	/**
	 * Zamch karty.
	 * @param co - karty co se maj zamchat
	 * @param kam - kam se maj karty zamchat
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 */
	void zamichat(String co, String kam, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		StringTokenizer st=new StringTokenizer(umisteno(kam, tahle, lokalString, lokalInt));
		int hrac=Integer.parseInt(st.nextToken());
		String misto=st.nextToken();
		int a;
		if(hrac==pocetHracu)
			a=1;
		else
			a=0;
		if(co.equals("all"))
			for(int i=0;i<umisteniKaret.size();++i)
				for(String s:umisteniKaret.get(i).keySet())
					move(i+"."+s, kam, tahle, lokalString, lokalInt);
		else
			move(co, kam, tahle, lokalString, lokalInt);
		if(viditelnost.get(a).get(misto)[0]){
			for(int i=0;i<umisteniKaret.get(hrac).get(misto).size();++i)
				for(int j=0;j<odeslani.size();++j)
					if(viditelnost.get(a).get(misto)[2-a]||a==0&&viditelnost.get(a).get(misto)[1]&&j==hrac)
						odeslani.get(j).out.println("del "+hrac+" "+misto+" "+karty.indexOf(umisteniKaret.get(hrac).get(misto).get(i))+" true");
					else
						odeslani.get(j).out.println("del "+hrac+" "+misto+" "+karty.indexOf(umisteniKaret.get(hrac).get(misto).get(i))+" false");
		}
		else if(umisteniKaret.get(hrac).get(misto).size()>0){
			for(int j=0;j<odeslani.size();++j)
				if(viditelnost.get(a).get(misto)[2-a]||a==0&&viditelnost.get(a).get(misto)[1]&&j==hrac)
					odeslani.get(j).out.println("del "+hrac+" "+misto+" "+karty.indexOf(umisteniKaret.get(hrac).get(misto).getLast())+" true");
				else
					odeslani.get(j).out.println("del "+hrac+" "+misto+" "+karty.indexOf(umisteniKaret.get(hrac).get(misto).getLast())+" false");
		}
		if(co.equals("all")){
			umisteniKaret.get(hrac).put(misto, new LinkedList<HashMap<String, String>>());
			umisteniKaret.get(hrac).get(misto).addAll(karty);
		}
		LinkedList<HashMap<String, String>> balik=new LinkedList<HashMap<String, String>>();
		balik.addAll(umisteniKaret.get(hrac).get(misto));
		for(int i=0;i<balik.size();++i){
			int karta=karty.indexOf(balik.get(i));
			for(int j=0;j<pocetHracu;++j){
				odeslani.get(j).out.println("shuffle "+karta);
			}
		}
		umisteniKaret.get(hrac).put(misto, new LinkedList<HashMap<String, String>>());
		while(balik.size()!=0){
			umisteniKaret.get(hrac).get(misto).add(balik.remove(new Random().nextInt(balik.size())));
		}
		if(viditelnost.get(a).get(misto)[0]){
			for(int i=0;i<umisteniKaret.get(hrac).get(misto).size();++i)
				for(int j=0;j<odeslani.size();++j)
					if(viditelnost.get(a).get(misto)[2-a]||a==0&&viditelnost.get(a).get(misto)[1]&&j==hrac)
						odeslani.get(j).out.println("ins "+hrac+" "+misto+" "+karty.indexOf(umisteniKaret.get(hrac).get(misto).get(i))+" true");
					else
						odeslani.get(j).out.println("ins "+hrac+" "+misto+" "+karty.indexOf(umisteniKaret.get(hrac).get(misto).get(i))+" false");
		}
		else if(umisteniKaret.get(hrac).get(misto).size()>0){
			for(int j=0;j<odeslani.size();++j)
				if(viditelnost.get(a).get(misto)[2-a]||a==0&&viditelnost.get(a).get(misto)[1]&&j==hrac)
					odeslani.get(j).out.println("ins "+hrac+" "+misto+" "+karty.indexOf(umisteniKaret.get(hrac).get(misto).getLast())+" true");
				else
					odeslani.get(j).out.println("ins "+hrac+" "+misto+" "+karty.indexOf(umisteniKaret.get(hrac).get(misto).getLast())+" false");
		}
	}
	
	/**
	 * Zjiuje absolutn msto zadan relativn nebo hodnoty parametr karet.
	 * @param kde - msto
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 * @return msto nebo hodnotu
	 */
	String umisteno(String kde, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		StringTokenizer st=new StringTokenizer(kde, ".");
		String hrac=st.nextToken();
		if(hrac.equals("this"))
			return tahle;
		else if(hrac.equals("stred"))
			hrac=((Integer)pocetHracu).toString();
		else if(st.hasMoreTokens())
			hrac=((Integer)vypocty(hrac, lokalInt)).toString();
		else{
			int karta=Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1));
			return karty.get(karta).get(hrac);
		}
		String misto=st.nextToken();
		if(!st.hasMoreTokens())
			return hrac+" "+misto;
		String co=st.nextToken();
		if(co.equals("first"))
			co=((Integer)karty.indexOf(umisteniKaret.get(Integer.parseInt(hrac)).get(misto).getFirst())).toString();
		else if(co.equals("last"))
			co=((Integer)karty.indexOf(umisteniKaret.get(Integer.parseInt(hrac)).get(misto).getLast())).toString();
		else if(co.startsWith("get"))
			co=((Integer)karty.indexOf(umisteniKaret.get(Integer.parseInt(hrac)).get(misto).get(vypocty(co.substring(co.indexOf("(")+1, co.length()-1), lokalInt)))).toString();
		else if(co.startsWith("contains")){
			while(st.hasMoreTokens())
				co+="."+st.nextToken();
			for(int i=0;i<umisteniKaret.get(Integer.parseInt(hrac)).get(misto).size();++i){
				int a=karty.indexOf(umisteniKaret.get(Integer.parseInt(hrac)).get(misto).get(i));
				if(podminky(co.substring(9, co.length()-1), hrac+" "+misto+" "+a, lokalString, lokalInt))
					return "true";
			}
			return "false";
		}
		else if(co.startsWith("size"))
			return ((Integer)umisteniKaret.get(Integer.parseInt(hrac)).get(misto).size()).toString();
		if(!st.hasMoreTokens())
			return hrac+" "+misto+" "+co;
		String parametr=st.nextToken();
		return karty.get(Integer.parseInt(co)).get(parametr);
	}
	
	/**
	 * Vypote hodnotu vrazu zadanho parametrem.
	 * @param co - vraz k vypoten
	 * @param lokalInt - lokln promnn
	 * @return hodnota vrazu
	 */
	int vypocty(String co, HashMap<String, Integer> lokalInt){
		while(co.contains("(")){
			int parovani=0;
			for(int i=co.indexOf("(");i<co.length();++i){
				if(co.charAt(i)=='(')
					++parovani;
				else if(co.charAt(i)==')')
					--parovani;
				if(parovani==0){
					parovani=i;
					break;
				}
			}
			String pred;
			String za;
			if(co.indexOf("(")==0)
				pred="";
			else
				pred=co.substring(0, co.indexOf("("));
			if(parovani==co.length()-1)
				za="";
			else
				za=co.substring(parovani+1);
			co=pred+vypocty(co.substring(co.indexOf("(")+1, parovani), lokalInt)+za;
		}
		if(co.contains("+")||co.contains("-"))
			if(co.indexOf("+")>co.indexOf("-"))
				return vypocty(co.substring(0, co.indexOf("+")), lokalInt)+vypocty(co.substring(co.indexOf("+")+1), lokalInt);
			else
				return vypocty(co.substring(0, co.indexOf("-")), lokalInt)-vypocty(co.substring(co.indexOf("-")+1), lokalInt);
		if(co.contains("*")||co.contains("/"))
			if(co.indexOf("*")>co.indexOf("/"))
				return vypocty(co.substring(0, co.indexOf("*")), lokalInt)*vypocty(co.substring(co.indexOf("*")+1), lokalInt);
			else
				return vypocty(co.substring(0, co.indexOf("/")), lokalInt)/vypocty(co.substring(co.indexOf("/")+1), lokalInt);
		if(co.contains("%"))
			return vypocty(co.substring(0, co.indexOf("%")), lokalInt)%vypocty(co.substring(co.indexOf("%")+1), lokalInt);
		if(lokalInt.containsKey(co))
			return lokalInt.get(co);
		else if(promenneInt.containsKey(co))
			return promenneInt.get(co);
		else if(co.equals("tah"))
			return tah;
		else if(co.equals("pocethracu"))
			return pocetHracu;
		else
			return Integer.parseInt(co);
	}
	
	/**
	 * Vyhodnot zadanou podmnku.
	 * @param co - podmnka ke zkontrolovn
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 * @return true jestli podmnka plat, jinak false
	 */
	boolean podminky(String co, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		StringTokenizer and=new StringTokenizer(co, "&&");
		boolean vnejsi=true;
		while(and.hasMoreTokens()){
			StringTokenizer or=new StringTokenizer(and.nextToken(), "||");
			boolean vnitrni=false;
			while(or.hasMoreTokens()){
				String cele=or.nextToken();
				boolean negace=false;
				if(cele.startsWith("not ")){
					negace=true;
					cele=cele.substring(4);
				}
				String a;
				String b;
				int operator;
				if(cele.contains("contains(")){
					int pocet=0;
					for(int i=9;i<cele.length();++i){
						if(cele.charAt(i)=='(')
							++pocet;
						else if(cele.charAt(i)==')')
							--pocet;
						if(pocet!=0&&i==cele.length()-1){
							if(!or.hasMoreTokens()){
								cele+="&&";
								or=new StringTokenizer(and.nextToken(), "||");
								cele+=or.nextToken();
							}
							else
								cele+="||"+or.nextToken();
						}
					}
					if(umisteno(cele, tahle, lokalString, lokalInt).equals("true")){
						if(negace)
							return false;
						else
							return true;
					}
					else if(negace)
						return true;
					else
						return false;
				}
				else if(cele.contains("=")){
					StringTokenizer operatory=new StringTokenizer(cele, "=");
					a=operatory.nextToken();
					b=operatory.nextToken();
					operator=0;
				}
				else if(cele.contains("<")){
					StringTokenizer operatory=new StringTokenizer(cele, "<");
					a=operatory.nextToken();
					b=operatory.nextToken();
					operator=1;
				}
				else{
					StringTokenizer operatory=new StringTokenizer(cele, ">");
					a=operatory.nextToken();
					b=operatory.nextToken();
					operator=2;
				}
				if(!tahle.equals("")&&karty.get(Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1))).containsKey(a)||a.contains("."))
					a=umisteno(a, tahle, lokalString, lokalInt);
				else if(a.contains("\""))
					a=a.substring(1, a.length()-1);
				else if(lokalString.containsKey(a))
					a=lokalString.get(a);
				else if(promenneString.containsKey(a))
					a=promenneString.get(a);
				else if(lokalInt.containsKey(a))
					a=lokalInt.get(a).toString();
				else
					a=((Integer)vypocty(a, lokalInt)).toString();
				if(!tahle.equals("")&&karty.get(Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1))).containsKey(b)||b.contains("."))
					b=umisteno(b, tahle, lokalString, lokalInt);
				else if(b.contains("\""))
					b=b.substring(1, b.length()-1);
				else if(lokalString.containsKey(b))
					b=lokalString.get(b);
				else if(promenneString.containsKey(b))
					b=promenneString.get(b);
				else
					b=((Integer)vypocty(b, lokalInt)).toString();
				if(operator==0){
					if(a.equals(b))
						vnitrni=true;
				}
				else if(operator==1){
					if(porovnani.contains(a)){
						if(porovnani.indexOf(a)<porovnani.indexOf(b))
							vnitrni=true;
					}
					else{
						if(Integer.parseInt(a)<Integer.parseInt(b))
							vnitrni=true;
					}
				}
				else{
					if(porovnani.contains(a)){
						if(porovnani.indexOf(a)>porovnani.indexOf(b))
							vnitrni=true;
					}
					else{
						if(Integer.parseInt(a)>Integer.parseInt(b))
							vnitrni=true;
					}
				}
				if(negace)
					if(vnitrni)
						vnitrni=false;
					else
						vnitrni=true;
				if(vnitrni)
					break;
			}
			if(!vnitrni){
				vnejsi=false;
				break;
			}
		}
		if(vnejsi)
			return true;
		else
			return false;
	}
	
	/**
	 * Piad hodnotu do promnn.
	 * @param co - hodnota k piazen
	 * @param kam - promnn, do kter se piazuje
	 * @param tahle - aktuln karta
	 * @param lokalString - lokln Stringov promnn
	 * @param lokalInt - lokln intov promnn
	 */
	void priradit(String co, String kam, String tahle, HashMap<String, String> lokalString, HashMap<String, Integer> lokalInt){
		String s;
		if(co.startsWith("show"))
			s=show(co.substring(co.indexOf(" ")+1), tahle, lokalString, lokalInt);
		else if(co.contains("\""))
			s=co.substring(1, co.length()-1);
		else if(!tahle.equals("")&&karty.get(Integer.parseInt(tahle.substring(tahle.lastIndexOf(" ")+1))).containsKey(co)||co.contains("."))
			s=umisteno(co, tahle, lokalString, lokalInt);
		else if(lokalString.containsKey(co))
			s=lokalString.get(co);
		else if(promenneString.containsKey(co))
			s=promenneString.get(co);
		else
			s=((Integer)vypocty(co, lokalInt)).toString();
		if(lokalString.containsKey(kam))
			lokalString.put(kam, s);
		else if(lokalInt.containsKey(kam))
			lokalInt.put(kam, Integer.parseInt(s));
		else if(promenneString.containsKey(kam))
			promenneString.put(kam, s);
		else if(promenneInt.containsKey(kam))
			promenneInt.put(kam, Integer.parseInt(s));
		else
			lokalInt.put(((Integer)vypocty(kam, lokalInt)).toString(), Integer.parseInt(s));
	}
	
	/**
	 * Spust metodu ke kontrole konce hry.
	 * @param tahle aktuln karta
	 */
	void konec(String tahle){
		for(String[] i:hlavicky.keySet())
			if(i[0].equals("konec")){
				HashMap<String, String> lokalString=new HashMap<String, String>();
				HashMap<String, Integer> lokalInt=new HashMap<String, Integer>();
				StringTokenizer st=new StringTokenizer(i[1]);
				while(st.hasMoreTokens())
					lokalString.put(st.nextToken(), "");
				st=new StringTokenizer(i[2]);
				while(st.hasMoreTokens())
					lokalInt.put(st.nextToken(), 0);
				proved(program.get(hlavicky.get(i)), tahle, lokalString, lokalInt);
				if(lokalString.get("konec").equals("true")){
					for(String[] j:hlavicky.keySet()){
						if(j[0].equals("konec2"))
							proved(program.get(hlavicky.get(j)), tahle, lokalString, lokalInt);
					}
				}
				for(int j=0;j<odeslani.size();++j)
					odeslani.get(j).out.println("next "+tah);
			}
	}
	
	/**
	 * Metoda run tdy Thread.
	 */
	public void run(){
		try{
			while(true){
				String radek=in.readLine();
				if(radek.equals("end"))
					throw new IOException();
				if(tah==poradi){
					StringTokenizer st=new StringTokenizer(radek);
					String co=st.nextToken();
					int hrac=Integer.parseInt(st.nextToken());
					String misto=st.nextToken();
					if(co.equals("klik")){
						int karta=Integer.parseInt(st.nextToken());
						LinkedList<LinkedList<String>> metoda=null;
						HashMap<String, String> lokalString=null;
						HashMap<String, Integer> lokalInt=null;
						int priorita=-1;
						for(String[] key:hlavicky.keySet()){
							if(key[0].equals("klik")&&key[2].equals(misto)&&((key[1].equals("this")&&hrac==poradi)||
									(key[1].equals("other")&&hrac!=poradi)||(key[1].equals("stred")&&hrac==pocetHracu)||
									(key[1].equals("all")&&hrac<pocetHracu))){
								if(Integer.parseInt(key[3])>priorita&&(key[4].equals("all")||podminky(key[4], hrac+" "+misto+" "+karta, new HashMap<String, String>(), new HashMap<String, Integer>()))){
									priorita=Integer.parseInt(key[3]);
									metoda=program.get(hlavicky.get(key));
									lokalString=new HashMap<String, String>();
									lokalInt=new HashMap<String, Integer>();
									st=new StringTokenizer(key[5]);
									while(st.hasMoreTokens())
										lokalString.put(st.nextToken(), "");
									st=new StringTokenizer(key[6]);
									while(st.hasMoreTokens())
										lokalInt.put(st.nextToken(), 0);
								}
							}
						}
						if(metoda!=null){
							proved(metoda, hrac+" "+misto+" "+karta, lokalString, lokalInt);
							konec(hrac+" "+misto+" "+karta);
						}
					}
					else if(co.equals("button")){
						LinkedList<LinkedList<String>> metoda=null;
						HashMap<String, String> lokalString=null;
						HashMap<String, Integer> lokalInt=null;
						for(String[] key:hlavicky.keySet()){
							if(key[0].equals("button")&&key[2].equals(misto)&&((key[1].equals("this")&&hrac==poradi)||
									(key[1].equals("other")&&hrac!=poradi)||(key[1].equals("stred")&&hrac==pocetHracu)||
									(key[1].equals("all")&&hrac<pocetHracu))){
								metoda=program.get(hlavicky.get(key));
								lokalString=new HashMap<String, String>();
								lokalInt=new HashMap<String, Integer>();
								st=new StringTokenizer(key[3]);
								while(st.hasMoreTokens())
									lokalString.put(st.nextToken(), "");
								st=new StringTokenizer(key[4]);
								while(st.hasMoreTokens())
									lokalInt.put(st.nextToken(), 0);
							}
						}
						if(metoda!=null){
							proved(metoda, "", lokalString, lokalInt);
							konec("");
						}
					}
				}
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
		} finally{
			for(Server i:odeslani)
				try {
					out.println("end");
					i.socket.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
				}
			try {
				odeslani=new LinkedList<Server>();
				s.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
			}
		}
	}
}
